/* -------------------------------------------------------------------- */
/* macros                                                               */
/* -------------------------------------------------------------------- */
#define PB(O, P, N)     fprintf(stdout, "%6.3f %6.3f %3d\n", O, P, N)
#define PH(a,b,c,d) fprintf(pdbout,"HETATM%5d%4s %4s %5d    ", a, b, c, d)
#define PN(a,b,c,d) fprintf(pdbout,"ATOM  %5d  %3s %3s %5d    ", a, b, c, d)
#define PP(f, O) fprintf(f,"%8.3f%8.3f%8.3f  1.00 10.00\n",O[XX], O[YY], O[ZZ])
#define PNP(f,a,b,c,d,O,oc,bf) fprintf(f,"ATOM  %5d  %3s %3s %5d    %8.3f%8.3f%8.3f %5.2f %5.2f\n",\
 a, b, c, d, O[XX], O[YY], O[ZZ], oc, bf)
#define PPF(f, O) fprintf(f,"%8.3f%8.3f%8.3f %5.2f %5.2f\n",O[XX], O[YY], O[ZZ], O[DIM3+OC], O[DIM3+BF])
#define PL(f, O) fprintf(f," %.3f %.3f %.3f",O[XX], O[YY], O[ZZ])

#define P1(O)   fprintf(out, " %5.1f", O)
#define PC(fi, le)      fprintf(fi, "%c", le)
#define PR(a,b,c,d,k,l) fprintf(out, "DISRST    %5d %5d %5.1f %5.1f %4.1f %4.1f ", a, b, c, d, k, l)
#define PRET(fi)        fprintf(fi, "\n")

#define NEW(object)             (object*)calloc(1, sizeof(object))
#define NEWN(dim, object)       (object*)calloc((unsigned)(dim), sizeof(object))
#define FREE(object)            free(object)
#define RENEWN(ptr, dim, object)       (object *)realloc(ptr, (unsigned)(dim)*sizeof(object))

#define CARRE(O1)       (O1*O1)

#define PM(a, b, c)     ((pm = sqrt(a*a + b*b + c*c))? 1./pm:0.)

#define GET_DIST(O1, O2) (sqrt((double)((O1[XX] - O2[XX])*(O1[XX] - O2[XX]) + \
                                (O1[YY] - O2[YY])*(O1[YY] - O2[YY]) + \
                                 (O1[ZZ] - O2[ZZ])*(O1[ZZ] - O2[ZZ]))))

#define SQR_DIS(O1, O2) ((O1[XX] - O2[XX])*(O1[XX] - O2[XX]) + \
                                (O1[YY] - O2[YY])*(O1[YY] - O2[YY]) + \
                                 (O1[ZZ] - O2[ZZ])*(O1[ZZ] - O2[ZZ]))

#define CB_DIS(O) ((O[XX] - O->xb)*(O[XX] - O->xb) + (O[YY] - O->yb)*(O[YY] - O->yb) + \
		(O[ZZ] - O->zb)*(O[ZZ] - O->zb))

#define PTR_DIS(O) ((O[XX] - O->xc)*(O[XX] - O->xc) + (O[YY] - O->yc)*(O[YY] - O->yc) + \
		(O[ZZ] - O->zc)*(O[ZZ] - O->zc))

#define ANG_CMP(O1, O2) sqrt(\
(sin(O1) - sin(O2))*(sin(O1) - sin(O2)) + (cos(O1) - cos(O2))*(cos(O1) - cos(O2)) )

#define CP_XYZ(O1, O2) (O1[XX] = O2[XX]); (O1[YY] = O2[YY]); (O1[ZZ] = O2[ZZ])

#define TV(a, i, s)     (a < s && a > i)
#define MIN(a, b)       ((a < b)?  a : b)
#define MAX(a, b)       ((a > b)?  a : b)
#define TT(d3, d4, i, s, j, t)     ((d3 < s && d3 > i) && (d4 < t && d4 > j))

/* -------------------------------------------------------------------- */
/* end of macros.h                                                      */
/* -------------------------------------------------------------------- */
