/* Alignment de sequences et de support(s) tridimensionnels */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <unistd.h>

#include "TITO/tito.h"
#include "TITO/codesup.h"
#include "TITO/comp.h"
#include "TITO/bb.h"
#include "TITO/macro2.h"

/*----------------------------------------------------------------------*/
/* variables                                                            */
/*----------------------------------------------------------------------*/
FILE	*pdbout = NULL, *out = NULL, *sup = NULL, *msfout = NULL;

char	***sek;
char	*srot[N_ETAT], **chimie[2], **chemie[2];
int	*ATMNUM[2], *SUPERNUM, *HP[N_ATOM], *HETNUM[2], **TS;
double	**ATOM, **HETATM;
float	**coin; 

char	**nom_sm[N_TYPE], **arg, **BIBAL, **CHATTE, **CMPND, **succes;
 
char	*out_pdb = "supsupsup.pdb\0", *file_out = "supsupsup.log\0", 
	*file_sup = "supsupsup.out\0", *file_msf = "supsupsup.msf\0";

int	*pf, *nf, *pl, *mini, *opti, **loop[N_CC], *E_L, *AS, **TAS, limmsf[2] = {0, -1}, **E_STS; 
int	***TABLA, *LISTE, *BLITZ, *renum, *REV, *TCT[3], *frg[2], *REAL, **RESULT, *SCALE[N_TYPE];
char	*fff, **SABLE, **RABLE;
double  *REF;
char	valse[N_TYPE][3] = {{'A','Z',UA},{'A','Z',UA},{'a','c','u'-'a'},{'0','1','2'-'0'}};

int 	N_PAR = 6, N_CHR = 6, N_GEN = 0, N_SUP = 10, INCR = 0, N_NOM[N_TYPE] = {0, 0, 0, 0}, PDBLUS = 0,
	ORDRE = 0, CC = 0, STOP = 20*500, UV = 0, N_AS = 0, MAXIM = 0, N_F_L = 0, N_SUC = 0,
	P_RES = 0, N_HET = 0, N_TOT = 0, max_name = 0, FRANC = 0, CHAFIX = 0, POLFIX = 0,
	N_CT = 0, N_FRAG = 0, N_RF = 0, NMRCHA = 0, MAXIMA = 1200,
	MINIMA = 10, VALSEQ = 1, VALSTS = 2, VALHYD = 400, VALIDL = 4, DECIDL = 115, HCAHCA = 0,
	ANC_N_FRAG = 0, ANC_N_CT = 0, ANC_N_HET = 0, ANC_N_TOT = 0, ANC_P_RES = 0;

double	Emaxou = -500000., *ETC, *FINAL;

char	*occ = "  1.00 10.00";
char    *atmtype[N_ATOM] = {"N  ","CA ","C  ", "O  ", "CB "};

double  d_ext = 9.99 * 9.99;
int	INDELS = +100, VERBES = 0;

double disbbk = 2.53, idbbbk = 1./1.54, angbbk = D2R*(35.), dihbbk = D2R*(180+57.);
double bbk[3] = {1., 0., 0.};

char    trans_seq[26] =
{'A','B','C','D','E','F','G','H','I','.','K','L','M','N','.','P','Q','R','S','T','.','V','W','X','Y','Z'};


extern	double	rms_brm[DIM3][DIM3];

/*----------------------------------------------------------------------*/
/* fonctions                                                            */
/*----------------------------------------------------------------------*/

extern  double *coo_geo_center(double **sec, double *cn1, int length);
extern  double rap_eqm(double **p1, double **b2, int ll, double *cn1, double *cn2);

extern	double	atom_dihed(double *t, double *t1, double *t2, double *t3);
extern	double	atom_angle(double *t, double *t1, double *t2);
void 	atom_pos(double *t, double *t1, double *t2, double *t3, double xn, double yn, double zn);  
void	analyse_cons234(float **coin, char **srot, double **ATOM, int *HP[N_ATOM], int n);
/*----------------------------------------------------------------------*/
/* ouverture                                                            */
/*----------------------------------------------------------------------*/
FILE    *ouvre_fichier(FILE *louvre, char *filin, char *option, char *mes)
{
        if ((louvre = fopen(filin, option))== NULL){
                fprintf(stdout,"\nOuverture %s : '%s' impossible\n", mes, filin);
                return NULL;
        }

return louvre;
}
/********************************************************/
/* aa							*/
/********************************************************/
char	***add_aa(char e, char ***s, int sm, int ns)
{
 	if (!(s[sm][ns] = RENEWN(s[sm][ns], TS[sm][ns]+1, char))) exit(1); 
	s[sm][ns][TS[sm][ns]] = e;	
	TS[sm][ns]++;

return s;
}
/********************************************************/
/* collecte						*/
/********************************************************/
int	*add_val(int *SCA[N_TYPE], int num, int val, int sm)
{

	if (!(SCA[sm] = RENEWN(SCA[sm], num, int ))) exit(1);
	SCA[sm][num-1] = val;

return SCA[sm];
}
/********************************************************/
/* collecte						*/
/********************************************************/
char	**add_name(char **name, char *naam, int sm)
{

	if (!(nom_sm[sm] = RENEWN(nom_sm[sm], N_NOM[sm]+1, char *))) exit(1);
	if (!(nom_sm[sm][N_NOM[sm]] = NEWN(strlen(naam)+1, char ))) exit(1);
	strncpy(nom_sm[sm][N_NOM[sm]], naam, strlen(naam));
 	N_NOM[sm]++;

return nom_sm[sm];
}
/********************************************************/
/* lecture						*/
/********************************************************/
char	***lecture_seq(char line[LL], char ***s, int sm, int ns, int mn)
{
	int	i;
	char	e;

	for (i = BORDURE+mn; i < MLF; i++){
		if ((e = line[i]) == ' ')
			continue;
		if (e >= valse[sm][0] && e  <= valse[sm][1]){   /* b1, b2 */
			s = add_aa(e-valse[sm][0], s, sm, ns);
		}
		else
		if (e == '.' || e == '*')
			s = add_aa(valse[sm][2], s, sm, ns);
	}

return s;
}
/*-----------------------------------------------------------------------*/
/* calcul de la valeur 'Check' pour la compatibilite avec GCG            */
/*-----------------------------------------------------------------------*/
int	GCGCheckSum(char *sek, int max)
{
	int 	i;
	char 	e;
	long 	check = 0;

	for (i = 0; i < max; i++){
		if ((e = sek[i]) == UA){
			check += ((i%57)+1)*(46); /* '.' == 46 */
		}
		else
			check += ((i%57) + 1) * (e+'A');
	}
/*	fprintf(stdout, "\n\tCheck %2d : %6d\n", n, check%10000);*/
	
return (check%10000);
}
/********************************************************/
/* construction de E_STS !!				*/
/********************************************************/
void	bd_sts(char ***sek)
{
	int	i, j, d, u, v, as, n, s, nb;
	char	e;
	float	inv_n_nom = 1./N_NOM[MDL], inv_valsts = 1.;

	if (!(E_L = NEWN(TS[MDL][0], int))) exit(1);
	if (!(E_STS = NEWN(TS[MDL][0], int *))) exit(1);
	for (i = 0; i < TS[MDL][0]; i++)
		if (!(E_STS[i] = NEWN(4, int))) exit(1);

	for (i = 0, u = 0; i < TS[MDL][0]; i++){
		for (nb = 0, n = 0; nb == 0 && n <N_NOM[MDL]; n++){
			if ('U'-'A' != sek[MDL][n][i])
				nb++;
		}
		if (nb == 0){
			E_L[i-u] = 0;
			continue;	/* mise a zero si pas d'aa de 0 a N_NOM[MDL] */
		}
		e = sek[MDL][0][i];
      		E_L[i-u] = VALIDL*(PROTIT[e][COIL]-DECIDL); /* propension a etre en boucle */
		for (s = 0; s < 4; s++)
      			E_STS[i-u][s] = PROTIT[e][s]; /* propension a etre en sts */
		if (N_NOM[MDL]>1){
			for (n = 1; n <N_NOM[MDL]; n++){
				e = sek[MDL][n][i];
                		E_L[i-u] += VALIDL*(PROTIT[e][COIL]-DECIDL);
			}
                	E_L[i-u] = (int)(E_L[i-u]*inv_n_nom);
			for (s = 0; s < 4; s++){
			   for (n = 1; n <N_NOM[MDL]; n++){
				e = sek[MDL][n][i];
      				E_STS[i-u][s] += PROTIT[e][s];
			   }
                	   E_STS[i-u][s] = (int)(.1*E_STS[i-u][s]*inv_n_nom);
			}
		}
		for (s = 0; s < 4; s++)
      			E_STS[i-u][s] *= VALSTS; /* propension a etre en sts */
	}
}
/********************************************************/
/* construction de TABLA !!				*/
/* matrices "triangulaire" superieure!! 		*/
/* (M(i,j,d) avec i > j.				*/
/********************************************************/
int	***bd_table(char ***seq)
{
	int	i, j, d, u, v, as, n;
	char	*E, *F;
	float	inv_n_nom = 1./N_NOM[MDL];

	if (!(E = NEWN(N_NOM[MDL], char)) || !(F = NEWN(N_NOM[MDL], char))) exit(1);

	if (!(TABLA = NEWN(TS[MDL][0], int **))) exit(1);
	if (!(REAL = NEWN(TS[MDL][0], int))) exit(1);
	MAXIM = TS[MDL][0];

	for (d = 0; d < 6; d++){
               	MATH[UA][d] += INDELS;
	}
	for (i = 0, u = 0; i < TS[MDL][0]; i++){
		for (n = 0; n <N_NOM[MDL]; n++)
			E[n] = sek[MDL][n][i];
		REAL[i-u] = i;
		if (!(TABLA[i-u] = NEWN(i-u, int *)))
			exit(1);
		for (j = 0, v = 0; j < i; j++){
			for (n = 0; n <N_NOM[MDL]; n++)
				F[n] = sek[MDL][n][j];
			if (!(TABLA[i-u][j-v] = NEWN(6, int )))  /* ATTENTION */
				exit(1);
			for (d = 0; d < 6; d++){
                	  TABLA[i-u][j-v][d] = MATB[E[0]][F[0]][d] + MATH[E[0]][d] + MATH[F[0]][d];
			  if (N_NOM[MDL]>1){
			    for (n = 1; n <N_NOM[MDL]; n++)
                	      TABLA[i-u][j-v][d] += MATB[E[n]][F[n]][d] + MATH[E[n]][d] + MATH[F[n]][d];
			    TABLA[i-u][j-v][d] = (int)((float)TABLA[i-u][j-v][d]*inv_n_nom);
			  }
			}
		}
	}
	for (i = 0, u = 0; i < TS[MDL][0]; i++){
		if ((E[0] = sek[MDL][0][i]) == UA){
			u++;
			continue;
		}
		if ((as = AS[i-u])){
		    fprintf(stdout,"%c %d\n",sek[MDL][0][i]+'A', i-u+1);
		    for (j = 0, v = 0; j < i; j++){
			if ((F[0] = sek[MDL][0][j]) == UA){
				v++;
				continue;
			}
			if (as == AS[j-v])
			    for (d = 0; d < 6; d++)
                		TABLA[i][j][d] += VAL_AS; /* u et v nuls ailleurs */
		    }
		}
	}

return TABLA;
}
/********************************************************/
/* lecture						*/
/********************************************************/
char	**bd_rable(char ***sek, int *SCALE[N_TYPE], int **TS)
{
	int	i, j, d, v, u, n, h;

	SCALE[HYD] = add_val(SCALE, N_NOM[HYD]+1, VALHYD, HYD);

	if (!(RABLE = NEWN(N_NOM[HYD]+1, char *))) exit(1);
	for (n = 0; n < N_NOM[HYD]; n++)
		if (!(RABLE[n] = NEWN(TS[HYD][0], char))) exit(1);
	if (!(RABLE[n] = NEWN(TS[MDL][0], char))) exit(1);

	for (n = 0; n < N_NOM[HYD]; n++)
	   for (i = 0, u = 0; i < TS[MDL][0] && i < TS[HYD][n]; i++){
		RABLE[n][i-u] = sek[HYD][n][i];
	   }
	for (i = 0, u = 0; i < TS[MDL][0]; i++){
                RABLE[N_NOM[HYD]][i-u] = 0;
		for (n = 0, h = 0; n < N_NOM[MDL]; n++)
			RABLE[N_NOM[HYD]][i-u] += HYDRE_26[sek[MDL][n][i]];

   			/* 0 = hydrophiles. 1 = hydrophobes */
		/*if (h == 0)
   			RABLE[N_NOM[HYD]][i-u] = 0; 
		else{
		  if (h == N_NOM[MDL]){
   			RABLE[N_NOM[HYD]][i-u] = 1; 
			}
		  else
			RABLE[N_NOM[HYD]][i-u] = 2;
		}*/
	}
	nom_sm[HYD] = add_name(nom_sm[HYD], "hydrophobe\0", HYD);

return RABLE;
}
/********************************************************/
/* lecture						*/
/********************************************************/
char	**bd_sable(char ***sek)
{
	int	i, j, d, u, v, as, n;

	if (!(SABLE = NEWN(N_NOM[PRD], char *))) exit(1);
	for (n = 0; n < N_NOM[PRD]; n++)
		if (!(SABLE[n] = NEWN(TS[PRD][n], char))) exit(1);

	for (n = 0; n < N_NOM[PRD]; n++){
		for (i = 0, u = 0; i < TS[MDL][n] && i < TS[PRD][n]; i++){
   			SABLE[n][i-u] = sek[PRD][n][i]; /* correspondance des str. sec. */
 		}
	}

return SABLE;
}
/* ---------------------------------------------------- */
/* detection des fragments a partir des sts		*/
/* ---------------------------------------------------- */
void    prep_sek(char ***sek)
{
	int	c, d, j = 0, k, i, rf = 0;
	char	e, f;

	for (i = 0; i < TS[MDL][0]-1; i++){
		for (j = 0; j < N_NOM[MDL]; j++)
			if (sek[MDL][j][i] != UA)
				break;
		if (j ==  N_NOM[MDL]) {
			for (j = 0; j < N_NOM[SPT]; j++)
				if (sek[SPT][j][i] != UA)       
                                break;
			if (j ==  N_NOM[SPT]){	
				for (k = 0; k < N_TYPE; k++) {
				   for (j = 0; j < N_NOM[k]; j++) {
					sek[k][j][i] = sek[k][j][i+1];
				   TS[k][j]--;
					}
				}
			}
		}
	}

}
/********************************************************/
/* lecture						*/
/********************************************************/
char	***bd_seq(char ***sek)
{
	int	i, d, totseq = 0, ideseq = 0, tothyd = 0, idehyd = 0;

	/*prep_sek(sek);*/

	if (N_NOM[SPT]){
	   for (i = 0; i < TS[MDL][0] && i < TS[SPT][0]; i++){
		if (sek[MDL][0][i] == UA || sek[SPT][0][i] == UA){
			continue;
		}
		if (sek[MDL][0][i] == sek[SPT][0][i])  /* pas compter U == U */
			ideseq++;
		totseq++;
		if (HYDRE_26[sek[MDL][0][i]] == 1){
			 if (1 == HYDRE_26[sek[SPT][0][i]])  /* pas compter U == U */
				idehyd++;
			tothyd++;
		}
	   }
if (FRANC)
   	   fprintf(stdout, "\n\tNombre d'acides amines MSF %d %d \n", TS[MDL][0], TS[SPT][0]);
else
   	   fprintf(stdout, "\n\tNumber of amino acids MSF %d %d \n", TS[MDL][0], TS[SPT][0]);
	   if ( TS[MDL][0] == 0 && TS[SPT][0] == 0){
		fprintf(stdout, "\n\t\tTrouble de l'ordre !!\n");
		exit(1);
	   }
if (FRANC){
fprintf(stdout, "\n\tNombre de residus identiques communs %d/%d %5.2f\n", ideseq, totseq, (float)ideseq/totseq);
fprintf(stdout, "\n\tNombre de residus hydrophobes communs %d/%d %5.2f\n", idehyd, tothyd, (float)idehyd/tothyd);
}
else
fprintf(stdout, "Alignment of '%s' and '%s' (id: %.2f; hy: %.2f)\n", nom_sm[MDL][0], nom_sm[SPT][0], (float)ideseq/totseq, (float)idehyd/tothyd);
	}

	if (!(AS = NEWN(TS[MDL][0], int))) exit(1);
	for (i = 0; i < N_AS && TAS[i][0] < TS[MDL][0]; i++)
		AS[TAS[i][0]] = TAS[i][1];				/* si AS[n] == p, n appartient au site p */
	
return sek;
}
/********************************************************/
/* renomme						*/
/********************************************************/
char	*renome_msf(char *name, int max_name)
{
	int	i, d, m;
	char	*nom_tp = NULL; 

	if (!(nom_tp= NEWN(max_name, char) )) exit(1); 
	/*for (i = 0; i < max_name; i++)
		nom_tp[i] = ' ';*/

	if ((d=strlen(name)) < max_name){
		for (i = 0; i < max_name-d; i++)
			nom_tp[i] = ' ';
		for (m = 0; i < max_name && m < d; i++, m++)
			nom_tp[i] = name[m];
		for (i = 0; i < max_name; i++)
			name[i] = nom_tp[i];
		name[i] = '\0';
	}
	/*for (i = 0; i<10; i++)		nom_tp[i] = ' ';*/

return name;
}
/********************************************************/
/* verifie						*/
/********************************************************/
int	verifie_msf(FILE *fil_seq, char ***nom_sm)
{
	int	**found, d, i, j;
	char	line[LL], *buffle;

        if (!(buffle= NEWN(LL, char) )) exit(1);
        if (!(found= NEWN(N_TYPE, int *) )) exit(1);
	for (d = 0; d < N_TYPE; d++)
        	if (!(found[d] = NEWN(N_NOM[d], int) ) )
			exit(1);
		else
			for (i = 0; i < N_NOM[d]; i++)
				found[d][i] = 0;

	while(fgets(line, LL, fil_seq)){
		for (j = 0; j < LL; j++)
			buffle[j] = '\0';
		if (strncmp(line," Name:",6) == 0){
		   sscanf(line+6,"%s", buffle);
/*	fprintf(stdout, "Name:(%s)\n", buffle);*/
		   if (strlen(buffle) > max_name)
			max_name = strlen(buffle);
		   for (d = 0; d < N_TYPE; d++)
			for (i = 0; i < N_NOM[d]; i++){
/*	fprintf(stdout, "(%s)  [%s] %d \n", buffle, nom_sm[d][i], max_name);*/
		   		if (strcmp(buffle, nom_sm[d][i]) == 0){
					found[d][i]++;
		   		}
			}
		}
		if (strncmp(line, "//", 2) == 0)
			break;
		for (i = 0; i < LL; i++)
			line[i] = '\0';
	}
	for (d = 0, i = 0; d < N_TYPE; d++)
		for (i = 0; i < N_NOM[d]; i++)
			if (found[d][i] != 1){
				fprintf(stdout, "\n\tUN NOM (%s) A ETE RETROUVE %d FOIS\n", nom_sm[d][i], found[d][i]);
				exit(1);
			}

	FREE(found);

	return max_name;

/*return 0;*/
}
/********************************************************/
/* lecture                                              */
/********************************************************/
void	check_len(char ***sek)
{
	int 	d, i, M = 0;
	char	valse[N_TYPE][3] = {{'A','Z',UA},{'A','Z',UA},{'a','c','u'-'a'},{'0','1','2'-'0'}};

	for (d = 0; d < N_TYPE; d++) {
		for (i = 0; i < N_NOM[d]; i++) 
			if (M < TS[d][i])
				M = TS[d][i];
	}
	for (d = 0; d < N_TYPE; d++) {
		for (i = 0; i < N_NOM[d]; i++) 
			if (TS[d][i] < M)
				while ( TS[d][i] == M)
					sek = add_aa(valse[d][2], sek, d, i);
	}
}
/********************************************************/
/* lecture						*/
/********************************************************/
void	blabla()
{
	if (N_NOM[SPT] > 0){
if (FRANC)
fprintf(stdout, "\n\tAlignement de '%s' avec '%s' \n", nom_sm[MDL][0], nom_sm[SPT][0]);
/*else
fprintf(stdout, "Alignment of '%s' and '%s' \n", nom_sm[MDL][0], nom_sm[SPT][0]);*/
	}
	else{
if (FRANC)
fprintf(stdout, "\n\tRecherche de supports pour '%s'\n", nom_sm[MDL][0]);
else
fprintf(stdout, "Search for folds compatible with '%s'\n", nom_sm[MDL][0]);
	}
}
/********************************************************/
/* lecture						*/
/********************************************************/
char	***lecture_msf(char ***sek, char *arg1)
{
	int	i, d, m, max_name = 0;
	char	line[LL];
	FILE	*fil_seq = NULL;

	if(!(fil_seq = ouvre_fichier(fil_seq, arg1, "r", "du fichier d'entree MSF"))) exit(1);
	
	if (!(max_name = verifie_msf(fil_seq, nom_sm))) exit(1);
 
	for (d = 0; d < N_TYPE; d++)
		for (i = 0; i < N_NOM[d]; i++) {
			nom_sm[d][i] = renome_msf(nom_sm[d][i], max_name);
		}
	
        if (!(sek = NEWN(N_TYPE, char **) )) exit(1);
	for (d = 0; d < N_TYPE; d++)
        	if (!(sek[d] = NEWN(N_NOM[d], char *) ) ) exit(1);
        if (!(TS= NEWN(N_TYPE, int *) )) exit(1);
	for (d = 0; d < N_TYPE; d++) {
        	if (!(TS[d] = NEWN(N_NOM[d], int) ) ) exit(1);
		for (i = 0; i < N_NOM[d]; i++) TS[d][i] = 0;
	}
if (FRANC)
fprintf(stdout, "\n\tUtilisation de %d structures et %d sequences\n", N_NOM[SPT], N_NOM[MDL]);
else
fprintf(stdout, "\nUse of %d structures and %d sequences in %s\n", N_NOM[SPT], N_NOM[MDL], arg1);

	for (i = 0; i < LL; i++)
		line[i] = '\0';
	fgets(line, LL, fil_seq);
	/*fgets(line, LL, fil_seq);*/
	while(fgets(line, LL, fil_seq)){
	    for (d = 0; d < N_TYPE; d++) {
		for (i = 0; i < N_NOM[d]; i++)
		   if (strncmp(line,nom_sm[d][i], max_name) == 0){
			lecture_seq(line, sek, d, i, max_name);
		   }
	    }
	    for (i = 0; i < LL; i++) line[i] = '\0';
	}

	check_len(sek);

	if (!(TS[HYD] = RENEWN(TS[HYD], N_NOM[HYD]+1, int))) exit(1);
	TS[HYD][N_NOM[HYD]] = TS[MDL][0];

	blabla();

	sek = bd_seq(sek);

	fclose (fil_seq);

	if (FRANC)
	fprintf(stdout, "\n\tLecture du fichier MSF '%s'\n", arg1);
	
return sek;
}
/* -------------------------------------------------------------------- */
/* addition des carbones Cbeta des glycines                             */
/* -------------------------------------------------------------------- */
void    put_cb_for_pmf(double **tp, int *HP[N_ATOM])
{
        int     n, nh, ca, cc,cb;
	double	dis;

        for (n = 0; n < P_RES; n++){
		ca = HP[CA][n];
		cb = HP[CB][n];
                if (srot[LET][n] == GA) {
			nh = HP[N][n]; cc = HP[C][n];
                	atom_pos(tp[cb], tp[cc], tp[ca], tp[nh],\
                	bbk[0], bbk[1]*cos(dihbbk), bbk[2]*sin(dihbbk));
		}
		/*	nh = HP[N][n]; cc = HP[C][n];
fprintf(stdout,"%.1f\n",R2D*atom_dihed(tp[cb], tp[cc], tp[ca], tp[nh]));*/
		dis = SQR_DIS(tp[ca],tp[cb]);
		mv_a_b(tp[ca], tp[cb], dis_pmf/sqrt(dis));  /*PMF*/
        }

}
/* ---------------------------------------------------- */
/* Rancon du succes					*/
/* ---------------------------------------------------- */
int    lect_succes(char line[LL])
{

	if (!(succes = RENEWN(succes, N_SUC+1, char *))) exit(1);
	if (!(succes[N_SUC] = NEWN(LL, char))) exit(1);
	strncpy(succes[N_SUC], line+7, strlen(line+7));
	/*sscanf(line+6, "%s", succes[N_SUC]);*/
	
return N_SUC++;
}
/* ---------------------------------------------------- */
/* Lecture des aa du site actif				*/
/* ---------------------------------------------------- */
int    lect_act_sit(char line[LL])
{
        int     f, c;

	sscanf(line+6, "%d %d", &f, &c);
	if (c == 0)
		return N_AS;
	if (!(TAS = RENEWN(TAS, N_AS+1, int *))) exit(1);
	if (!(TAS[N_AS] = NEWN(2, int))) exit(1);
	TAS[N_AS][0] = f-1;
	TAS[N_AS][1] = c;
	N_AS++;
	
return N_AS;
}
/* ---------------------------------------------------- */
/* Lecture des fragments				*/
/* ---------------------------------------------------- */
void    make_frag()
{
	if (!(frg[NTER] = RENEWN(frg[NTER], N_FRAG+1, int))) exit(1);
	if (!(frg[CTER] = RENEWN(frg[CTER], N_FRAG+1, int))) exit(1);
	if (!(fff = RENEWN(fff, N_FRAG+1, char))) exit(1);
}
/* ---------------------------------------------------- */
/* Lecture des fragments				*/
/* ---------------------------------------------------- */
int    lect_frag(char line[LL])
{
        int     f, f1, f2, f3 = FFL;

/*	if (N_FRAG >= ANC_N_FRAG)*/
		make_frag();

	sscanf(line+6, "%d %d %d", &f1, &f2, &f3);
	if (f1 > f2){
		f = f1;   f1 = f2;   f2 = f;
	}
	frg[NTER][N_FRAG] = f1-1;
	frg[CTER][N_FRAG] = f2-1;
	fff[N_FRAG] = f3;
	
return N_FRAG++;
}
/* ---------------------------------------------------- */
/* construction des fragments a partir des sts		*/
/* ---------------------------------------------------- */
int    bd_frag()
{
        int     i;
	char	sts = 'c';
						/* compte sts */
	for (i = 0; i < P_RES; i++){
		if (srot[CONS][i] == COIL){
			continue;
		}
/*		if (N_FRAG >= ANC_N_FRAG)*/
			make_frag();

		sts = srot[CONS][i];
		frg[NTER][N_FRAG] = i;
		fff[N_FRAG] = FFL;	
		for (; i < P_RES && srot[CONS][i] == sts; i++)
			sts = srot[CONS][i];
		frg[CTER][N_FRAG] = i;	
		N_FRAG++;
	}
return N_FRAG;
}
/********************************************************/
/* fragments d'apres l'alignement				*/
/********************************************************/
int	deduce_frag()
{
        int     d, i;
							/*observe les indels */
	for (i = 0, d = 0; i-d < P_RES && i < TS[SPT][0]; i++){
		if (sek[SPT][0][i] == UA){
			d++;
			continue;
		}
		if (sek[MDL][0][i] == UA){
			continue;
		}
		/*if (N_FRAG >= ANC_N_FRAG)*/
			make_frag();

		frg[NTER][N_FRAG] = i-d;
		if (N_GEN == 0)
			fff[N_FRAG] = FFF;	

		for (; i-d < P_RES && i < TS[SPT][0] && sek[SPT][0][i] != UA && sek[MDL][0][i] != UA; i++);

		frg[CTER][N_FRAG] = i-d;
		if (sek[SPT][0][i] == UA)
			d++;	
		N_FRAG++;
	}
return N_FRAG;
}
/********************************************************/
/* fragments d'apres l'alignement				*/
/********************************************************/
int	cluster_frag()
{
        int     i, casse, end_cluster;
	int	CASSE_26[26] = {0,2,0,2,1,0,2,1,0,0,1,0,0,2,0,4,1,1,2,1,0,0,0,0,0,1};
							/*observe les indels */
	for (i = 0; i < P_RES && i < TS[SPT][0]; i++){
		if ((srot[HYDRO][i] = HYDRE_26[srot[LET][i]]) == 0){
			continue;
		}
		casse = 0;
/*		if (N_FRAG >= ANC_N_FRAG)*/
			make_frag();

		frg[NTER][N_FRAG] = i;
		fff[N_FRAG] = FFL;	
		for (; i < P_RES && casse < 4; i++){
			if (srot[HYDRO][i] == 1){	
				casse = 0;
				end_cluster = i;
			}
			else
				casse += CASSE_26[srot[LET][i]];
		}
		frg[CTER][N_FRAG] = end_cluster+1;	
		N_FRAG++;
	}
return N_FRAG;
}
/********************************************************/
/* contacts						*/
/********************************************************/
void	list_contact()
{
	int	a = 0, b, d, i, j, k, m = 0, EO = 0, kd = 0, md = 0, dl = 0, hh = 0, hf = 0;
	char	g, e, f; 
	double	dis;

	for (i = 0; i < P_RES; i++)
		if (srot[HYDRO][i] == 1)
			hh++;
	for (i = 0; i < N_RF; i++)
		if (srot[HYDRO][LISTE[i]] == 1)
			hf++;

	for (k = 0; k < N_RF; k++){
		i = LISTE[k];
		for (m = 0, b = -1; m < k && m < N_RF; m++){
			j = LISTE[m];
			b++;
			if ((dis = SQR_DIS(ATOM[HP[CB][i]], ATOM[HP[CB][j]])) > d_ext)
				continue;
			if (dis < 16.0)
				continue;
			if (N_CT >= ANC_N_CT){
				if (!(TCT[F1] = RENEWN(TCT[F1], (N_CT+1),int))) exit(1);
				if (!(TCT[F2] = RENEWN(TCT[F2], (N_CT+1),int))) exit(1);
				if (!(TCT[DISC] = RENEWN(TCT[DISC], (N_CT+1),int))) exit(1);
				ANC_N_CT++;
			}
			TCT[F1][N_CT] = a; 
			TCT[F2][N_CT] = b; 
			d = TCT[DISC][N_CT] = (int)(sqrt(dis) - 4.0);
			/*d = TCT[DISC][N_CT] = ISQ[(int)dis] - 4;*/
			e = srot[LET][i];
			f = srot[LET][j];
			EO += MATB[e][f][d] + MATH[f][d] + MATH[e][d];
			N_CT++;
		}
		a++;
	}
if (FRANC)
	fprintf(stdout, "\tEnergie originale (%d contacts) : %5d  [ %d/%d ]\n\n", N_CT, EO, hf, hh);
else
        fprintf(stdout, "\tOriginal energy (%d contacts) : %5d  [ %d/%d ]\n\n", N_CT, EO, hf, hh);

}
/* -------------------------------------------------------------------- */
/* detection des fragments a partir des sts si pas definis avant        */
/* -------------------------------------------------------------------- */
int    verif_frag()
{
	int	k, c, i;
	double	dis;

	for (k = 1; k < N_FRAG; k++){
	  if (frg[CTER][k] < frg[NTER][k-1] || (N_NOM[SPT] && frg[CTER][k] > TS[SPT][0])){
		if (FRANC)
			fprintf(stdout, "\n\nFragment n_%d inacceptable\n", k);
		else
			fprintf(stdout, "\nImpossible fragment n_%d\n", k);
		return(0);
	  }
	}
	for (k = 0; k < N_FRAG; k++){
		if (fff[k] == 0)
			N_F_L++;
		N_RF += nf[k] = frg[CTER][k] - frg[NTER][k];
/*	fprintf(stdout, "\n\tTaille du fragment n_%d : %d\n", k, nf[k]);*/
	}
	if (FRANC)
		fprintf(stdout, "\tTaille du coeur commun (%d fragments) : %d\n", N_FRAG, N_RF);
	else
		fprintf(stdout, "\tSize of the common core (%d fragments) : %d\n"
, N_FRAG, N_RF);


	if (!(renum = RENEWN(renum, N_RF, int))) return(0);	

	if (N_RF > TS[MDL][0]) return 0;

	if (!(LISTE = RENEWN(LISTE, N_RF, int))) return(0);	

	c = 0;
	for (k = 0; k < N_FRAG; k++){
		for (i = frg[NTER][k]; i < frg[CTER][k]; i++)
			LISTE[c++] = i;
	}

	if (!(BLITZ = RENEWN(BLITZ, N_F_L, int))) return(0);	
	c = 0;
	for (k = 0; k < N_FRAG; k++){
		if (fff[k] == 0)
			BLITZ[c++] = k;
	}

	opti[0] = frg[NTER][0];
	for (k = 1; k < N_FRAG; k++){
		opti[k] = frg[NTER][k] - frg[CTER][k-1];
	}
	opti[N_FRAG] = P_RES-frg[CTER][N_FRAG-1];

	mini[0] = 0;
	for (k = 1; k < N_FRAG; k++){
		dis = SQR_DIS(ATOM[HP[CA][frg[NTER][k]]], ATOM[HP[CA][frg[CTER][k-1]]]);
		mini[k] = (int)(sqrt(dis)/3.5);
		mini[k] = MAX(mini[k]-1, 0);
	  /*fprintf(stdout, "\n\tTaille minimale n_%d : %d\n", k, mini[k]);*/
	}
	mini[N_FRAG] = 0;

	/*if (N_FRAG >= ANC_N_FRAG) */
	   for (c = 0; c < N_CC; c++)
		for (k = 0; k < N_CHR; k++)
			if (!(loop[c][k] = NEWN(N_FRAG+1, int))) exit(1);

return N_FRAG;
}
/* -------------------------------------------------------------------- */
/* detection des fragments a partir des sts si pas definis avant        */
/* -------------------------------------------------------------------- */
int	detect_frag()
{
	int	k;

	if (N_FRAG == 0){
		if (HCAHCA)
			cluster_frag();
		else{
		if (N_NOM[SPT])
			deduce_frag();
		else
			bd_frag();
		}
	}
	if (N_FRAG == 0)
		return(0);

	if (!(mini = RENEWN(mini, N_FRAG+1, int)) || !(opti = RENEWN(opti, N_FRAG+1, int)) || 
		 !(pl = RENEWN(pl, N_FRAG+1, int)) ||
		!(nf = RENEWN(nf, N_FRAG, int)) || !(pf = RENEWN(pf, N_FRAG, int)))
			exit(1);	

return	verif_frag(); /* renvoi de N_FRAG */
}
/* ---------------------------------------------------- */
/* detection des fragments a partir des sts		*/
/* ---------------------------------------------------- */
void    deduce_loop(char ***sek)
{
	int	c, d, j = 0, k, i, rf = 0;
	char	e, f;

	for (k = 0; k < N_FRAG+1; k++)
		loop[0][0][k] = 0;
	for (i = 0, d = 0, k = 0; i < TS[MDL][0] && k < N_FRAG; i++){
		e = sek[MDL][0][i];
		f = sek[SPT][0][i];
		if (e == UA && f == UA){
			loop[0][0][k]++;
			d++;
		 	continue;
		}
		if (e == UA){ 
			loop[0][0][k]++;
		 	continue;
		}
		if (f == UA){ 
			loop[0][0][k]++;
			d++;	
		 	continue;
		}
		if (i-d == frg[NTER][k]){
			k++;
			continue;
		}
	}
	for (; i<TS[MDL][0]; i++){
		f = sek[SPT][0][i];
		if (f == UA) 
			loop[0][0][k]++;
	}
/*	for (k = 0; k < N_FRAG+1; k++)
		c+= loop[0][0][k];
	fprintf(stdout,"\n\tLOUP %5d \n\n", c);*/

	for (c = 0; c < N_CC; c++)
	   for (j = 0; j < N_CHR; j++)
		for (k = 0; k < N_FRAG+1; k++)
			loop[c][j][k] = loop[0][0][k];

}
/* --------------------------------------------------------------- */
/* construction des atomes                                         */
/* --------------------------------------------------------------- */
int	extrait_atm(int n, char *c, int p, int l)
{
	int	j, k;

	for (j = 0; ATMNUM[AA_NUM][j] == ATMNUM[AA_NUM][n]; j++)
		for (k = 0; k < l; k++)
			if(chimie[0][n][p+k] == c[k])
				return j;

return -1;
}
/* --------------------------------------------------------------- */
/* copie conforme des atomes                                       */
/* --------------------------------------------------------------- */
void    cp_aa(double **am, char **ck[2], int **num, int n, char ligne[LL])
{
        int     i;

	/*r->chain = ligne[21];*/
        num[AT_NUM][n] = atoi(ligne+6);
        num[AA_NUM][n] = atoi(ligne+22);
        am[n][XX] = atof(ligne+30);
        am[n][YY] = atof(ligne+38);
        am[n][ZZ] = atof(ligne+46);
        am[n][DIM3+OC] = atof(ligne+54);
        am[n][DIM3+BF] = atof(ligne+60);

        strncpy(ck[0][n], ligne+13, NS);
        strncpy(ck[1][n], ligne+17, NS);

}
/* --------------------------------------------------------------- */
/* construction des atomes                                         */
/* --------------------------------------------------------------- */
void    bd_aa(char ligne[LL])
{
        int     i;

	if (N_TOT >= ANC_N_TOT){
        	if (!(ATOM = RENEWN(ATOM, N_TOT+1, double *))) exit(1);
		if (!(ATOM[N_TOT] = NEWN(DIM3+OCBF, double))) exit(1);

       		if (!(ATMNUM[AT_NUM] = RENEWN(ATMNUM[AT_NUM], N_TOT+1, int ))) exit(1);
      		if (!(ATMNUM[AA_NUM] = RENEWN(ATMNUM[AA_NUM], N_TOT+1, int ))) exit(1);

        	for (i = 0; i < 2; i++){
        		if (!(chimie[i] = RENEWN(chimie[i], N_TOT+1, char *) )) exit(1);
                	if (!(chimie[i][N_TOT] = NEWN(LNS, char))) exit(1);
		}
		ANC_N_TOT++;
        }

	cp_aa(ATOM, chimie, ATMNUM, N_TOT, ligne);

	N_TOT++;

}
/* --------------------------------------------------------------- */
/* construction des atomes                                         */
/* --------------------------------------------------------------- */
void    bd_gly(char ligne[LL])
{
        int     i;

	if (N_TOT >= ANC_N_TOT){
		if (!(ATOM = RENEWN(ATOM, N_TOT+1, double *))) exit(1);
		if (!(ATOM[N_TOT] = NEWN(DIM3+OCBF, double))) exit(1);

		if (!(ATMNUM[AT_NUM] = RENEWN(ATMNUM[AT_NUM], N_TOT+1, int ))) exit(1);
		if (!(ATMNUM[AA_NUM] = RENEWN(ATMNUM[AA_NUM], N_TOT+1, int ))) exit(1);

        	for (i = 0; i < 2; i++){
        		if (!(chimie[i] = RENEWN(chimie[i], N_TOT+1, char *) )) exit(1);
                	if (!(chimie[i][N_TOT] = NEWN(LNS, char))) exit(1);
        	}
		ANC_N_TOT++;
        }

        ATMNUM[AT_NUM][N_TOT] = atoi(ligne+6)+1;
        ATMNUM[AA_NUM][N_TOT] = atoi(ligne+22);
        strncpy(chimie[0][N_TOT], "CB ", NS);
        strncpy(chimie[1][N_TOT], ligne+17, NS);

	N_TOT++;

}
/* -------------------------------------------------------------------- */
/* construction des heteratomes                                         */
/* -------------------------------------------------------------------- */
void    bd_het(char ligne[LL])
{
	int	i;

	if (N_HET >= ANC_N_HET) {
        	if (!(HETATM = RENEWN(HETATM,N_HET+1, double *))) exit(1);
        	if (!(HETATM[N_HET] = NEWN(DIM3+OCBF, double))) exit(1);

        	if (!(HETNUM[AT_NUM] = RENEWN(HETNUM[AT_NUM], N_HET+1, int ))) exit(1);
        	if (!(HETNUM[AA_NUM] = RENEWN(HETNUM[AA_NUM], N_HET+1, int ))) exit(1);

        	for (i = 0; i < 2; i++) {
        		if (!(chemie[i] = RENEWN(chemie[i], N_HET+1, char *))) exit(1);
        		if (!(chemie[i][N_HET] = NEWN(LNS, char))) exit(1);
        	}
		ANC_N_HET++;
        }

	cp_aa(HETATM, chemie, HETNUM, N_HET, ligne);

	N_HET++;
}
/********************************************************/
/* lecture du fichier PDB				*/
/********************************************************/
void	complete_pdb(int *HP[N_ATOM])
{
	int	j, k, numaa, c_b = 4;

	for (j = 0; j < N_TOT; j++){
		if (j == 0 || ATMNUM[AA_NUM][j] != ATMNUM[AA_NUM][j-1]){
			if (c_b < 4 || (c_b < 3 && srot[LET][numaa] == 'G'-'A'))
				P_RES--;
			if (!( SUPERNUM = RENEWN(SUPERNUM, P_RES+1, int) )) exit(1);
			for (k = 0; k < N_ATOM; k++){
				if (!(HP[k] = RENEWN(HP[k], P_RES+1, int) )) exit(1);
			}
			for (k = 0; k < N_ETAT; k++){
				if (!(srot[k] = RENEWN(srot[k], P_RES+1, char) )) exit(1);
			}
			SUPERNUM[P_RES] = j;
			numaa = P_RES;
			P_RES++;
			c_b = 0;
		}
		if ( !strncmp(chimie[0][j], "CA ", 3)){ 
			c_b++;
			for (k = 0; k < N_AA; k++)
		               if (strncmp(chimie[1][j], CODE3L[k],3) == 0){
                        	        srot[LET][numaa] = CODE1L[k] - 'A';
					break;
				}
		}
		else{
		   if ( !strncmp(chimie[0][j], "N  ", 3)) 
			c_b++;
		   else
		   	if ( !strncmp(chimie[0][j], "C  ", 3)) 
				c_b++;
		}
		srot[HYDRO][numaa] = HYDRE_26[srot[LET][numaa]];
		for (k = 0; k < N_ATOM; k++){
			if (!strncmp(chimie[0][j], atmtype[k],3)){
				HP[k][numaa] =  j;
				break;
			}
		}
		if (!strncmp(chimie[0][j], "CB ", 3)){
			c_b++;
		}
	}
	if (c_b < 4 || (c_b < 3 && srot[LET][numaa] == 'G'-'A'))
		P_RES--;
        fprintf(stdout, "    (%d, %d, %d)\n",P_RES, N_TOT, N_HET);

	put_cb_for_pmf(ATOM, HP);
	
	free(coin);
	analyse_cons234(coin, srot, ATOM, HP, P_RES);
/*	fprintf(stdout,"\n");
	for (k = 0; k < P_RES; k++)
		fprintf(stdout,"%c", srot[CONS][k]+'a');
	fprintf(stdout,"\n");*/

}
/********************************************************/
/* lecture du fichier PDB				*/
/********************************************************/
void  lecture_pdb(char line[LL], char *arg6, char drap)
{
	int	j;

        if (arg6[0] == ' ' && N_TOT == 0 && line[21] != arg6[0] && !strncmp(line, "ATOM  ", 6))
                arg6[0] = line[21];

        if (strncmp(line, "ENDMDL",6) == 0){
		NMRCHA = 1;
                return;
        }

	if (line[21] != arg6[0] || NMRCHA == 1) return;

        if (strncmp(line+17,"HOH",3) == 0 || strncmp(line+17," HOH",4) == 0)
                return ;
        if (strncmp(line+17,"WAT",3) == 0 || strncmp(line+17,"TIP3",4) == 0)
                return ;

	if (!strncmp(line, "HETATM",6)){
        	bd_het(line);
		return;
	}
	
	if (strncmp(line, "ATOM  ", 6))
		return;
	if (line[13] == 'H')
		return;

        for (j = 0; j < N_AA; j++)
        	if (strncmp(line+17, CODE3L[j],3) == 0)
			break; 
	if (j == N_AA){		/* si nom de residu inconnu -> HETERO */
               	bd_het(line);
		return;
	}

        /*if (atoi(ligne+22) < nt || atoi(ligne+22) > ct)
		return;*/

	if (drap == 'A' && strncmp(line+13, "N  ", 3) && strncmp(line+13, "CA ", 3) 
			&& strncmp(line+13, "C  ", 3) && strncmp(line+13, "CB ", 3) )
		return;

	bd_aa(line);
	
	if (j == 'G'-'A' && strncmp(line+13, "CA ", 3) == 0)
		bd_gly(line); 

return ;
}
/********************************************************/
/* lecture du fichier PDB				*/
/********************************************************/
int  	check_pdb(char *arg2, char *arg6, char drap)
{
	char	line[LL];
	FILE	*fil_pdb = NULL;
	int	c, k, cmp;

	if (!(fil_pdb = ouvre_fichier(fil_pdb, arg2, "r", "du fichier PDB"))) return 0;
	if (FRANC)
		fprintf(stdout, "\nLecture du support 3D : %s ", arg2);
	else
		fprintf(stdout, "Reading 3D file: %s ", arg2);


	if (N_FRAG >= ANC_N_FRAG) 
		ANC_N_FRAG = N_FRAG;

	P_RES = 0; N_HET = 0; N_TOT = 0; N_CT = 0; N_FRAG = 0; N_RF = 0; CC = 0; 
	Emaxou = -500000.; INCR = 0; N_F_L = 0; NMRCHA = 0; cmp = 0;

	if (!(CMPND = RENEWN(CMPND,PDBLUS+1,char *))) exit(1);
	if (!(CMPND[PDBLUS] = NEWN(31, char))) exit(1);

	while (fgets(line, LL, fil_pdb)){
		if (cmp == 0 && strncmp(line,"COMPND",6) == 0){
			k = 0;
			if (strncmp(line+10,"MOL_ID: 1;",7) == 0)
				continue;
                        if (strncmp(line+9,"2 MOLECULE:",10) == 0)
                                k = 14;
			cmp = 1;
			for (c = 0; c < 30; c++)
				CMPND[PDBLUS][c] = line[c+k+6];
			
		}
		if (strncmp(line,"ATOM  ",6) == 0 || strncmp(line,"HETATM",6) == 0){
			lecture_pdb(line, arg6, drap);
			break;
		}
	}
	while (fgets(line, LL, fil_pdb)){
		lecture_pdb(line, arg6, drap);
	}
	fclose (fil_pdb);

        if (!N_TOT)
		return 0;

	complete_pdb(HP);

        if (P_RES < MINIMA || P_RES > MAXIMA)
		return 0;
	

return N_TOT;
}
/********************************************************/
/* sortie				hetero		*/
/********************************************************/
void	ecriture_hetero(double **HETATM, char **chemie[2], int nn, int n, FILE *out, FILE *pdbout)
{
	int 	h = 0;
	char	rimi[4];

        strncpy(rimi, chemie[1][h],NS);
        for (h = 0; h < N_HET; h++){
		if (strncmp(rimi, chemie[1][h],NS)){
			n++;
                	strncpy(rimi, chemie[1][h],NS);
		}
                fprintf(pdbout, "HETATM %4d  %s%s %4d    ", nn+1+h, chemie[0][h], chemie[1][h], n);
                PPF(pdbout, HETATM[h]);
                fprintf(out, "HETATM %4d  %s%s %4d    ", nn+1+h, chemie[0][h], chemie[1][h], n);
                PPF(out, HETATM[h]);
        }
}
/********************************************************/
/* sortie						*/
/********************************************************/
void	comments(char ***sek, FILE *pdbout)
{
	int	k, d = 0, i = 0, n_res = TS[MDL][0];

	for (k = 0; k < TS[MDL][0]; k++){
		if (sek[MDL][0][k] == 'U'-'A'){
			n_res--;
			continue;
		}
	}
	fprintf(pdbout, "REMARK 	TITO-made PDB file");
	fprintf(pdbout, "\nFORMAT (13X,A3,14X,3F8.3,6X,F6.2)"); /* AMoRe */
	for (k = 0; k < TS[MDL][0]; k++){
		if (sek[MDL][0][k] == 'U'-'A'){
			d++;
			continue;
		}
		if ((k-d)%13 == 0)
			fprintf(pdbout,"\nREMARK %3d %6d  ", ++i, n_res);
		if ((int)(sek[MDL][0][k]) >= AA && (int)(sek[MDL][0][k]) < ZA)
			fprintf(pdbout, "%3s ", CODE3L[sek[MDL][0][k]]);
		else
		fprintf(pdbout, "UNK ");
	}
	fprintf(pdbout,"\n");
}
/********************************************************/
/* sortie						*/
/********************************************************/
int	imp_chaine_lat(char e, int j, int nid, int id, FILE *pdbout, FILE *out, int matl)
{
	int	cln, cl, n, i, ca, cb, cg, cd, ce, cz, aan = AA_NUM, cmn;
	char	claire[4], clara[4];
	float	coco[1] = {0.};
	float	chine[NT_CHI] = {0.0,0.0,0.0,0.0};

	n = HP[N][j];
	if ( j < TS[SPT][0] && n+CG < N_TOT){ /* calcul des Chi_n a partir ces CooCar */
		/*ca = HP[CA][j];*/
		for (cb = CA; ATMNUM[aan][n] == ATMNUM[aan][n+cb] && chimie[0][n+cb][1] != 'B'; cb++);
		if (chimie[0][n+cb][1] != 'B')
			return nid;
		for (cg = cb; ATMNUM[aan][n] == ATMNUM[aan][n+cg] && chimie[0][n+cg][1] != 'G'; cg++);
		if (chimie[0][n+cg][1] == 'G'){
			chine[CHI1] = R2D*atom_dihed(ATOM[n+N], ATOM[n+CA], ATOM[n+cb], ATOM[n+cg]);
		}

		for (cd = cg;n+cd < N_TOT && ATMNUM[aan][n] == ATMNUM[aan][n+cd] && chimie[0][n+cd][1] != 'D'; cd++) ;
		if (n+cd < N_TOT && chimie[0][n+cd][1] == 'D')
			chine[CHI2] = R2D*atom_dihed(ATOM[n+CA], ATOM[n+cb], ATOM[n+cg], ATOM[n+cd]);

		for (ce = cd; n+ce < N_TOT && ATMNUM[aan][n] == ATMNUM[aan][n+ce] && chimie[0][n+ce][1] != 'E'; ce++) ;
		if (n+ce < N_TOT && chimie[0][n+ce][1] == 'E')
			chine[CHI3] = R2D*atom_dihed(ATOM[n+cb], ATOM[n+cg], ATOM[n+cd], ATOM[n+ce]);

		for (cz = ce; n+cz < N_TOT && ATMNUM[aan][n] == ATMNUM[aan][n+cz] && chimie[0][n+cz][1] != 'Z'; cz++) ;
		if (n+cz < N_TOT && chimie[0][n+cz][1] == 'Z')
			chine[CHI4] = R2D*atom_dihed(ATOM[n+cg], ATOM[n+cd], ATOM[n+ce], ATOM[n+cz]) ;
	}
	fprintf(out, " %d", CHAFIX);
	fprintf(out, " %.1f", chine[CHI1]);
	if (e == 'I'-'A' || e == 'L'-'A' || e == 'F'-'A' || e == 'Y'-'A'
			|| e == 'W'-'A'  || e == 'P'-'A' || e == 'N'-'A' || e == 'D'-'A' ) 
                			fprintf(out, " %.1f", chine[CHI2]);
	if ( e == 'M'-'A' || e == 'Q'-'A' || e == 'E'-'A' || e == 'K'-'A' || e == 'R'-'A' ) {
                			fprintf(out, " %.1f", chine[CHI2]);
                			fprintf(out, " %.1f", chine[CHI3]);
	}
	if (e == 'K'-'A' || e == 'R'-'A' ) {
			fprintf(out, " %.1f", chine[CHI4]);
	}

	cln = ATMNUM[AA_NUM][SUPERNUM[j]];
	/*strcpy(clara, CODE3L[e]);*/
	for (cmn = 1, cl = SUPERNUM[j]; cmn < matl && cl < N_TOT && ATMNUM[AA_NUM][cl] == cln; cl++){
		strcpy(claire, chimie[0][cl]);
	    	if (strncmp(claire, "N ",2) && strncmp(claire, "O ",2) && strncmp(claire, "CA ",3) 
			&& strncmp(claire, "C ",2) && strncmp(claire, "CB ",3)){
        /*fprintf(stdout, "ATOM %5d %s%s %4d \n", nid, chimie[0][cl], CODE3L[e], id+1);*/
        fprintf(pdbout, "ATOM  %5d  %s%s  %4d    ", nid, chimie[0][cl], CODE3L[e], id+1);
                		PPF(pdbout, ATOM[cl]);
	  			nid++;
	  			cmn++;
		}
	}
return nid;
}
/****************************************************************/
/* verifie les bords pour eviter les fixations aux indels	*/
/****************************************************************/
int	bouclage(int j, int i)
{
	int	d, nid = 1, w, h, cl = 0, cn;

	if (N_NOM[SPT] == 0)
		return 0;
	if (j == 0 || j == TS[SPT][0])
		return 0;
	for (h = 0; h < N_FRAG; h++)
		if (j == frg[NTER][h] || j == frg[CTER][h]-1)
			return 0;
	if (i == 0 || i == TS[MDL][0])
		return 0;
	else{
		if (sek[MDL][0][i-1] != UA && sek[SPT][0][i-1] != UA
			&&
			sek[MDL][0][i+1] != UA && sek[SPT][0][i+1] != UA)
			return 1;
	}
	/*if (TV(SQR_DIS(ATOM[HP[CA][j]], ATOM[HP[CA][j+1]]), i_D_CA, s_D_CA) &&
	      TV(SQR_DIS(ATOM[HP[CA][j]], ATOM[HP[CA][j-1]]), i_D_CA, s_D_CA))
		return 1; */

return 0;
}
/********************************************************/
/* sortie						*/
/********************************************************/
void	supervielle(FILE *out)
{
	char	e, f;
	int	i, j, ins = 0, del = 0, dec = 2;

	for (i = 0, j = 1; i < TS[MDL][0] && j < TS[MDL][0]; i++){
		e = sek[MDL][0][i];
		f = sek[SPT][0][i];
		if (e == UA && f == UA)
			continue;
		if (e == UA){
			del++;
			continue;
		}
		if (f == UA){
			ins++;
			j++;
			continue;
		}
		j++;
		if (ins && del == 0)
			fprintf(out,"BOUCLE %3d %3d %2d 4 4\n", MAX(0, j-ins-1-2), MIN(TS[MDL][0], j), ins);
		if (del && ins == 0)
			fprintf(out,"BOUCLE %3d %3d %2d 4 4\n", MAX(0, j-dec-1), MIN(TS[MDL][0], j), dec);
		if (del && ins){
			ins = MAX(ins,  del);	
			fprintf(out,"BOUCLE %3d %3d %2d 4 4\n", MAX(0, j-ins-1), MIN(TS[MDL][0], j), ins);
		}
		ins = 0;	
		del = 0;	
	}
}
/************************************************************************/
/* impression du fichier d'alignement de la 3D et de la 1D		*/
/************************************************************************/
char	*prepare_msf(int v, int vn, int pn, char *s)
{
	int	i, k, n, p = 0;

	if (!(s = NEWN(TS[MDL][0], char))) exit(1);

	for (k = 0; k < N_FRAG; k++) {
		for (i = 0; i < RESULT[v][k]; i++){
			s[p++] = '.';
		}
		for (i = frg[NTER][k]; i < frg[CTER][k]; i++){
			s[p++] = srot[LET][i]+'A';
		}
	}
	for (i = 0; i < RESULT[v][k]; i++){
		s[p++] = '.';
	}

	for (n = 0; n < N_NOM[MDL]; n++)
		for (i = 0; i < TS[MDL][n]; i++){
			if (sek[MDL][n][i] == UA)
				sek[MDL][n][i] = '.';
			else
				sek[MDL][n][i] += 'A';
		}	

return s;
}
/************************************************************************/
/* impression du fichier d'alignement de la 3D et de la 1D		*/
/************************************************************************/
char	*imprime_msf(int vc, char ***sek)
{
	int 	start = 0, incre = 0, i, longue, vn = N_NOM[SPT], pn = N_NOM[PRD], d = 0;
	char	*support = NULL, *nom_spt;

	for (i = 0; i < strlen(BIBAL[vc]); i++)
		if (BIBAL[vc][i] == '/')
			d = i+1;
	if (!( nom_spt = NEWN(strlen(BIBAL[vc])-d, char))) exit(1);

	for (i = 0; i < strlen(BIBAL[vc])-d && i < 10; i++){
		if (BIBAL[vc][i] == '.')
			break;
		else
			nom_spt[i] = BIBAL[vc][d+i];
	}
	nom_spt[i] = '\0';
	support = prepare_msf(vc, vn, pn, support);

	if (!(msfout = ouvre_fichier(msfout, file_msf, "w", "du fichier de sortie MSF"))) return NULL;

	fprintf(msfout," %s  Msf: %d  Type: P  PileUp-like from TITO   Check: 1996  ..\n\n",msfout,TS[MDL][0]);

	for (i = 0; i < N_NOM[MDL]; i++)
	   fprintf(msfout," Name: %10s       Len: %5d  Check: %4d  Weight:  1.00\n", nom_sm[MDL][i], TS[MDL][i], GCGCheckSum(sek[MDL][i], TS[MDL][i]));
	fprintf(msfout," Name: %10s       Len: %5d  Check: %4d  Weight:  1.00\n", nom_spt, TS[MDL][0], GCGCheckSum(support, TS[MDL][0]));
	fprintf(msfout,"\n//\n\n");

   while (start < TS[MDL][0] ){
	fprintf(msfout,"            %-5d",start);
	for (i = 20; i < LM; i+=10)
		fprintf(msfout,"           ");
	if (LM + start < TS[MDL][0])
		fprintf(msfout,"           %5d\n",LM - 1 + start);
	else
		fprintf(msfout,"           \n");

	for (d = 0; d < N_NOM[MDL]; d++){
	   fprintf(msfout,"%10s  ",nom_sm[MDL][d]);
	   for (i = 0; i < LM && (i + start) < TS[MDL][d]; i++) {
		fprintf(msfout,"%c", sek[MDL][d][i+start]);
		if ((i+1)%10 == 0)
			fprintf(msfout," ");	
	   }
	   fprintf(msfout,"\n");
	}
	fprintf(msfout,"%10s  ",nom_spt);
	for (i = 0; i < LM && (i + start) < TS[MDL][0]; i++) {
		fprintf(msfout,"%c", support[i+start]);
		if ((i+1)%10 == 0)
			fprintf(msfout," ");	
	}
	fprintf(msfout,"\n");
	start += i;
	fprintf(msfout,"\n");
   }
	if (FRANC)
	fprintf(stdout,"%s\n\n", file_msf);
	else
	fprintf(stdout," %s\n", file_msf);

	fclose(msfout);

return support;
}
/********************************************************/
/* energy						*/
/* mesure la compatibilite des sequences SEQMDL avec	*/ 
/* les structures secondaires observees dans STTSPT	*/
/********************************************************/
int	energy_sts(int sm, char ***SK)
{
	int	E_SM = 0, n, i, k, p;

	for (i = 0, p = 0; i < N_RF; i++, p++){
		E_SM += E_STS[renum[p]][srot[CONS][LISTE[i]]];
	}

return E_SM;
}
/********************************************************/
/* energy						*/
/* mesure la concordance des profiles hydrophobes	*/
/********************************************************/
int	energy_hyd(int sm, int t, char **SR)
{
	int	E_SM = 0, n, i, k, p;

	for (i = 0, p = 0; i < N_RF; i++, p++){
		if (srot[t][LISTE[i]] == 1) {
			for (n = 0; n < N_NOM[sm]; n++) {
				E_SM += SR[n][renum[p]]*SCALE[sm][n];
			}
		}
		else
		if (srot[t][LISTE[i]] == 0) {
			for (n = 0; n < N_NOM[sm]; n++) {
				E_SM -= SR[n][renum[p]]*SCALE[sm][n];
			}
		}
	}
/*	fprintf(stdout, "\n\t ATTENCION HYD = %5d\n", E_SM);*/

return E_SM;
}
/********************************************************/
/* energy						*/
/* 'srot' = proteine support				*/
/* mesure la concordance des sequences			*/
/* ou des structures secondaires	 		*/
/********************************************************/
int	energy_sup(int sm, int t, char **SR, int valmy)
{
	int	E_SM = 0, n, i, k, p;

	for (i = 0, p = 0; i < N_RF; i++, p++){
		for (n = 0; n < N_NOM[sm]; n++) {
			if (srot[t][LISTE[i]] == SR[n][renum[p]]){
				E_SM += SCALE[sm][n];
	/*			fprintf(stdout, "%c %c\n", srot[t][LISTE[i]]+'A', SR[n][renum[p]]+'A');*/
			}
		}
	}
	/*
	fprintf(stdout, "\t\t\t ATTENTION SUP = %5d %5d %5d\n", E_SM, valmy, t);
	*/

return((int)(.1*E_SM*valmy));
}
/********************************************************/
/* energie du coeur commun				*/
/********************************************************/
int	energy_core()
{
	int	E_Core = 0, c;
	
	for (c = 0; c < N_CT; c++){
	    E_Core -= TABLA[renum[TCT[F1][c]]][renum[TCT[F2][c]]][TCT[DISC][c]];
	}

return E_Core;
}
/********************************************************/
/* energy						*/
/* mesure la compatibilite des sequences SEQMDL avec	*/ 
/* les boucles deduites de l'alignement			*/
/********************************************************/
int	energy_loop(int nc)
{
	int	E_Loop = 0, n, i, help;
	
	for (n = 0; n < N_FRAG; n++){
		help = pl[n]+loop[CC][nc][n];
		for (i = pl[n]; i < help && i < TS[MDL][0]; i++){
			E_Loop += E_L[i];
		}
	}
	help = pl[n]+loop[CC][nc][n];
	for (i = pl[n]; i < help && i < TS[MDL][0]; i++){
		E_Loop += E_L[i];
/*fprintf(stdout, "\tLOOP  %9d %9d %d %d %d %d %d %d\n", E_Loop, E_L[i], pl[n]+loop[CC][nc][n], i, TS[MDL][0], loop[CC][nc][n], pl[n], help);*/
	}

return E_Loop;
}
/********************************************************/
/* position						*/
/********************************************************/
double	positionne(int nc)
{
	int	k, n, L, p = 0, et, r;

	/*
	for (k = 0, r = 0; k < N_FRAG; k++){
		r+= nf[k];
	}
	fprintf(stdout,"\tLOUP %5d \n", r);
	*/

	pl[0] = 0;	
	for (k = 0; k < N_FRAG; k++){
                pf[k] = pl[k]+loop[CC][nc][k];
                for (n = 0; n < nf[k]; n++){
                        renum[p] = n+pf[k];
                        p++;
                }
                pl[k+1] = pf[k]+nf[k];
        }

/*
fprintf(stdout, "\tFinal energy: %9d (%7.1f/%d contact) %7d %7d %7d %5d %5d\n\n", \
et = -energy_core(), (double)(et)/N_CT, N_CT, -energy_sts(MDL, sek), \
-energy_loop(0), -energy_sup(PRD, CONS, SABLE, VALSTS), -energy_hyd(HYD, HYDRO, RABLE) ,\
 -energy_sup(MDL, LET, sek[MDL], VALSEQ));
      */ 
return (
	energy_sts(MDL, sek)+
	energy_core()+
	energy_loop(nc)+
	energy_sup(MDL, LET, sek[MDL], VALSEQ)+
	energy_sup(PRD, CONS, SABLE, VALSTS)+
	energy_hyd(HYD, HYDRO, RABLE)); 		/* energie a maximiser */
/*+energy_sup(HYD, HYDRO, RABLE, VALHYD));*/
	/*return (rand()%500);*/
/*
*/
}
/********************************************************/
/* energie du coeur commun				*/
/********************************************************/
int	energy_plot()
{
	int	*E_Plot = NULL, c, E_Tot = 0;

	if (!(E_Plot = NEWN(TS[MDL][0], int)))
		return 0;
	
	for (c = 0; c < N_CT; c++){
	    E_Plot[renum[TCT[F1][c]]] += TABLA[renum[TCT[F1][c]]][renum[TCT[F2][c]]][TCT[DISC][c]];
	    E_Plot[renum[TCT[F2][c]]] += TABLA[renum[TCT[F1][c]]][renum[TCT[F2][c]]][TCT[DISC][c]];
	}

return E_Tot;
}
/********************************************************/
/* sortie par fragments					*/
/* a l'ecran avec les noms				*/
/********************************************************/
void	init_ligne(int r, char *ns)
{

	if (r%LL == 0) {
		fprintf(stdout,"\n");
		fprintf(stdout,"%s ", ns);
	}

}
/********************************************************/
/* sortie par fragments					*/
/* a l'ecran avec les noms				*/
/********************************************************/
void	expr_loop(char *ns, int lop, int ind)
{
	int	i, j;

	for (j = 0, i = 0; j < lop; j++){
	/*fprintf(stdout,"%c", ns[j+ind]+'A');*/
		if (ns[j+ind] != 'U'-'A')
			i++;
	}
	fprintf(stdout," (%d)", i);
}
/********************************************************/
/* sortie par fragments					*/
/* a l'ecran avec les noms				*/
/********************************************************/
void	sort_align()
{
	int	j, i, s, r = 0, n, d, et = 0, m = 0;
	char	e, f;

	for (n = 0; n < N_NOM[MDL]; n++){
		init_ligne(r, nom_sm[MDL][n]);
		expr_loop(sek[MDL][n], loop[CC][0][0], m);
	}
	for (n = 0; n < N_NOM[PRD]; n++){
		init_ligne(r, nom_sm[PRD][n]);
		expr_loop(sek[PRD][n], loop[CC][0][0], m);
	}
		init_ligne(r, nom_sm[SPT][0]);
	/*	expr_loop(srot[LET], loop[CC][0][0], m);*/
		expr_loop(sek[SPT][0], loop[CC][0][0], 0);	/* ???? */
	  fprintf(stdout,"\n");

	for (s = 0, i = 0; i < N_FRAG; i++){
	  /*if (FRANC)
	  fprintf(stdout,"\nBoucle n_%d (%4d).\n", i+1, loop[CC][0][i]);
	  else
	  fprintf(stdout,"\nLoop n_%d (%4d).\n", i+1, loop[CC][0][i]);*/

	  m += loop[CC][0][i]+nf[i];
	 /* for (n = 0; n < N_NOM[HYD]; n++){
	    r = 0;
	    for (j = 0; j < nf[i]; j++){
		init_ligne(r, nom_sm[HYD][n]);
		fprintf(stdout,"%c", HYDRE_26[sek[HYD][n][REAL[renum[s+j]]]]+'0');
		r++;
	    }
	  }
	  */
	  for (n = 0; n < N_NOM[MDL]; n++){
	    r = 0;
	    for (j = 0; j < nf[i]; j++){
		init_ligne(r, nom_sm[MDL][n]);
		fprintf(stdout,"%c", trans_seq[sek[MDL][n][REAL[renum[s+j]]]]);
		r++;
	    }
		expr_loop(sek[MDL][n], loop[CC][0][i+1], m);
	  }
	  for (n = 0; n < N_NOM[PRD]; n++){
	    r = 0;
	    for (j = 0; j < nf[i]; j++){
		init_ligne(r, nom_sm[PRD][n]);
		fprintf(stdout,"%c", sek[PRD][n][REAL[renum[s+j]]]+'a');
		r++;
	    }
	  }
	  s += nf[i];
	  r = 0;
	  for (j = 0; j < nf[i]; j++){
		init_ligne(r, nom_sm[SPT][0]);
		fprintf(stdout,"%c",  trans_seq[srot[LET][frg[NTER][i]+j]]);
		r++;
	  }
		expr_loop(sek[SPT][0], loop[CC][0][i+1], m);	
	  r = 0;
	  for (j = 0; j < nf[i]; j++){
		init_ligne(r, "Str. Sec. ");
		fprintf(stdout,"%c",  srot[CONS][frg[NTER][i]+j]+'a');
		r++;
	  }
	  fprintf(stdout,"\n");
	  r = 0;
	}
	/*if (FRANC)
	  fprintf(stdout,"\nBoucle n_%d (%4d).\n", i+1, loop[CC][0][i]);
	else
	  fprintf(stdout,"\nLoop n_%d (%4d).\n", i+1, loop[CC][0][i]);*/
	fprintf(stdout,"\n\n");
	if (FRANC)
fprintf(stdout, "\tEnergie finale : %9d (%.1f/contact) %7d %7d %7d %5d %5d\n\n", 
et = -energy_core(), (double)et/N_CT, \
-energy_sts(MDL, sek), -energy_loop(0), \
-energy_sup(PRD, CONS, SABLE, VALSTS), \
-energy_hyd(HYD, HYDRO, RABLE) , \
energy_sup(MDL, LET, sek[MDL], VALSEQ));
	else
fprintf(stdout, "Final energy: \n 3D Compatibility %7d (%.1f/contact) + \n \
2D Compatibility %7d + %7d + %5d \n 1D Compatibility %5d + %5d\n\n", \
et = -energy_core(),  (double)et/N_CT, \
-energy_sts(MDL, sek), -energy_loop(0), \
-energy_sup(PRD, CONS, SABLE, VALSTS), \
-energy_hyd(HYD, HYDRO, RABLE) ,\
-energy_sup(MDL, LET, sek[MDL], VALSEQ));
}
/********************************************************/
/* sortie						*/
/********************************************************/
void	entree_sortie()
{
	int	t, k;
	char	*index[N_TYPE] = {"SEQSPT\0","SEQSPT\0","STSPRD\0","HDRPHB\0"};

	if (!(sup = ouvre_fichier(sup, file_sup, "w", "du fichier de sortie"))) return;
	
 	fprintf(sup,"ALIMNT %s\n", arg[1]);
	fprintf(sup,"STTSPT %s\n", arg[2]);
	fprintf(sup,"STTMDL ");
	for (k = 0; k < strlen(arg[3])-1; k++){
		if ('.'==arg[3][k] && 'p' == arg[3][k+1])
			break;
		else
			fprintf(sup,"%c", arg[3][k]);
	}
	fprintf(sup,"\n");
	N_NOM[HYD]--;
	for (t = 0; t < N_TYPE; t++)
		for (k = 0; k < N_NOM[t]; k++)
			fprintf(sup,"%s %s\n", index[t], nom_sm[t][k]);

	fprintf(sup,"CHRMSN %d\n", N_CHR);
	fprintf(sup,"GENERA %d\n", N_GEN);
	fprintf(sup,"POLCHA %c\n", arg[6]);
	for (k = 0; k < N_FRAG; k++)
		fprintf(sup,"FRGMNT %4d %4d %d\n", frg[NTER][k]+1, frg[CTER][k]+1, fff[k]);
	for (k = 0; k < N_AS; k++)
		fprintf(sup,"ACTSIT %4d %d\n", TAS[k][0]+1, TAS[k][1]);
	fprintf(sup,"VALHYD %d\n", VALHYD);
	fprintf(sup,"VALIDL %d\n", VALIDL);
	fprintf(sup,"DECIDL %d\n", DECIDL);
	fprintf(sup,"VALSTS %d\n", VALSTS);
	fprintf(sup,"VALSEQ %d\n", VALSEQ);
	fprintf(sup,"HCAHCA %d\n", HCAHCA);
	fprintf(sup,"END\n");
}
/********************************************************/
/* sortie						*/
/********************************************************/
int	contest(int *lis)
{
	int	i, v = 0, valdam = 0, s;
	double	etabli = FINAL[0];
	char	*md3d = NULL;


	if (!(lis = NEWN(MIN(PDBLUS, N_SUP), int))) exit(1);	

	for (i = 0; i < PDBLUS; i++) {
		if (etabli < FINAL[i]){
			etabli = FINAL[i];
			v = i;
		}
		if (N_SUC >0 && strncmp(succes[0], BIBAL[i], strlen(succes[0])) == 0) {
			valdam = i;
		}
	}
	check_pdb(BIBAL[v], CHATTE[v], 'B');
	detect_frag();
	list_contact();
	for (i = 0; i < N_FRAG+1; i++)
		loop[CC][0][i] = RESULT[v][i];

	for (s = 0; s < N_SUC; s++) { 
	/*	fprintf(stdout, "\n\tESSAIS %d %s    %9.1f %s\n", s, BIBAL[s], -FINAL[s], CMPND[s]);*/
	  if (strncmp(succes[s], BIBAL[v], strlen(BIBAL[v])) == 0) {
		fprintf(stdout, "\n\tSUCCES pour %s : %s %9.1f %s\n", succes[0], BIBAL[v], -FINAL[v], CMPND[v]);
	  }
	}
	  if (N_SUC >0 && .90*FINAL[v] < 1.*FINAL[valdam]) {
		fprintf(stdout, "\n\tDAMNES %s    %9.1f %s\n", BIBAL[v], -FINAL[v], CMPND[v]);
	  }
	/*if (FRANC)
        fprintf(stdout, "\n\tSORTIE %s    %9.1f %s\n", BIBAL[v], -FINAL[v], CMPND[v]);*/

	if (N_NOM[SPT] == 0) {
		fprintf(stdout, "\n\tSORTIE %d\n", max_name);
		if (!(md3d = RENEWN(md3d, max_name, char))) exit(1);
		strncpy(md3d, "model 3D                 \0", max_name);
		md3d[max_name] = '\0';
		nom_sm[SPT] = add_name(nom_sm[SPT], md3d, SPT);
		SCALE[SPT] = add_val(SCALE, N_NOM[SPT], 1, SPT);
	}

return v;
}
/********************************************************/
/* sortie						*/
/********************************************************/
void	imp_squelette(FILE *pdbout, int nid, char *code, int res, double **ATOM, int *HP[N_ATOM], int j)
{
	int	i;

	for (i = N; i <= O; i++){
		PDB(pdbout, nid+i, CODE_AA[i], code, res, ATOM[HP[i][j]]); 
	}

}
/********************************************************/
/* sortie						*/
/********************************************************/
void	sortie(char ***sek)
{
	int	d, i, j, nid = 1, w, h, cl = 0, cn, vc = 0, p;
	int	m, k, n, nini, cln, vq = 0, *lisout = NULL, dec = 0;
	char	g, e, f, gg, ee, ff; 
	double	dis = 2.4;

	vc = contest(lisout);

	ETC[0] = positionne(0);

	sort_align();

	if (!(pdbout = ouvre_fichier(pdbout, out_pdb, "w", "du fichier PDB"))) return;
	if (!(out = ouvre_fichier(out, file_out, "w", "du fichier de sortie"))) return;
	if (FRANC)
	fprintf(stdout,"\n\tRepliement compatible : %s (%c) %s, %9.1f (%8.2f)\n\n",
			BIBAL[vc], CHATTE[vc][0], CMPND[vc], -FINAL[vc], -FINAL[vc]/N_CT);
	else
	fprintf(stdout,"Compatible fold: %s (%c) %s \nTotal energy:  %8.1f (%.1f/residue)\n",
			BIBAL[vc], CHATTE[vc][0], CMPND[vc], -FINAL[vc], -FINAL[vc]/N_CT);

	comments(sek, pdbout);

	if (FRANC)
        	fprintf(stdout, "\n\tEcriture de   %s   %s   ", out_pdb, file_out);
	else
		fprintf(stdout,"Writing files:   %s   %s  ", out_pdb, file_out);
	nid = 1;
	for (d = 0, k = 0, p = 0; k < N_FRAG; k++) {
		for (i = 0; i < RESULT[vc][k]; i++, p++){
			if ((e = sek[MDL][0][p]) == ('U'-'A')){
				d++;
				continue;
			}
			PL_0(out, e+'A', 'c');
		}
		for (j = frg[NTER][k]; j < frg[CTER][k]; j++, p++){
			if ((e = sek[MDL][0][p]) == ('U'-'A')){
				d++;
				continue;
			}
			f = srot[LET][j];
			g = srot[CONS][j];
			imp_squelette(pdbout, nid, CODE3L[e], p-d+1, ATOM, HP, j);
			mv_a_b(ATOM[HP[CA][j]], ATOM[HP[CB][j]], 1.54/dis_pmf); 
			if (e != GA && f != GA){
				PDB(pdbout, nid, "CB ", CODE3L[e], p-d+1, ATOM[HP[CB][j]]);
				nid++;
			}

			nid += N_ATOM-1;
		
			/*if (bouclage(j, p))
				PL1(out, e+'A', g+'a', ATOM[HP[CA][j]]); 
			else
				PLT(out, e+'A', g+'a', ATOM[HP[CA][j]]); */ /* gevrey */
			if ((MAT_SUP_L[e][f] || g != COIL) && bouclage(j, p) || POLFIX == 1)
				PL1(out, e+'A', g+'a', ATOM[HP[CA][j]]); 
			else
				PLT(out, e+'A', g+'a', ATOM[HP[CA][j]]); 
			PLB(out, ATOM[HP[CB][j]]); 
			PLB(out, ATOM[HP[N][j]]); 
			PLB(out, ATOM[HP[C][j]]); 
			/*PLB(out, ATOM[HP[O][j]]); */
			if (MAT_SUP_L[e][f] && e != GA && e != AA && (cl = SUPERNUM[j]) < N_TOT){
				nid = imp_chaine_lat(e, j, nid, p-d, pdbout, out, MAT_SUP_L[e][f]);
				
			}
			fprintf(out, "\n");
		}
	}

	for (; p < TS[MDL][0]; p++){
		if ((e = sek[MDL][0][p]) == ('U'-'A')){
			d++;
			continue;
		}
		PL_0(out, e+'A', 'c'); 
	}

	if (N_HET){
		ecriture_hetero(HETATM, chemie, nid, p-d+1, out, pdbout);
	}

	fprintf(pdbout, "END\n");
	fprintf(out, "ENDSEQ\n");
	if (N_NOM[SPT])
		supervielle(out);

	fprintf(out, "GENERA 0\n");
	fprintf(out, "EXTENS 0\n");
	fprintf(out, "BCLOPT 0\n");
	fprintf(out, "NUMBOU 0\n");
	fprintf(out, "PRIME  0\n");
	fprintf(out, "PRAME  0\n");
	fprintf(out, "LIMEQM 0.5\n");

	fclose (pdbout);
	fclose (out);

	imprime_msf(vc, sek); /* lisout */

	entree_sortie();

	if (FRANC)
	fprintf(stdout, "\n - FIN - \n\n");
	else
	fprintf(stdout, "THE END\n");

}
/************************************************************************/
/*	copiage								*/
/************************************************************************/
void	copie(int i, int o, int g2)
{
	int	n;

	for (n = 0; n < N_FRAG+1; n++){
		loop[g2][o][n] = loop[CC][i][n]; 
	}
}
/************************************************************************/
/*	clasement selon l'energie					*/
/************************************************************************/
int 	classe(double *Filtre)
{
	int	i, p, n, gen2 = (CC+1)%2, maxou = 0;
	double	Emin = Filtre[0], Emax = Filtre[0];
	double	Efiltre = 0., Er, Esom = 0.;

	copie(0, 0, gen2);
	for (i = 0; i < N_CHR; i++){
		Esom += Filtre[i];
		if (Filtre[i] <= Emin){
			Emin = Filtre[i];
		}
		else
			if (Filtre[i] > Emax){
				Emax = Filtre[i];
				maxou = i;
			}
	}
	
	if (Emax > Emaxou){
		/*fprintf(stdout,"\nEm %4d %9.1f %9.1f\n", maxou, -Filtre[maxou], -Filtre[0]);*/
		for (i = 0; i < DEB; i++)
			copie(maxou, i, gen2);		/* DEB > DEB_MUT */
		Emaxou = Emax;
		INCR = 0;
	}
	
	Esom = 1./(Esom - Emin * N_CHR);

	for (i = 0; i < N_CHR; i++){
		REF[i] = Efiltre += (Filtre[i] - Emin)*Esom;
	}
	for (p = DEB; p <N_PAR; p++) {			/* depart a 1,  minimum en zero */
		Er = (rand()%RANDO)*INV_RANDO;
		for (i = 1; i <N_CHR; i++){   			/* depart a 1 car (i-1) */
			if (REF[i] >= Er && Er > REF[i-1] ){
				copie(i, p, gen2);
				break;
			}
		}
		if (i == N_CHR)
			copie(maxou, p, gen2);
	}

return (CC = gen2);
}
/********************************************************/
/* mutagenese						*/
/********************************************************/
double 	*mutation(double *ETC)
{
	int	k, nc, L, M, i;

	for (nc = 0; nc < DEB; nc++){	
		ETC[nc] = positionne(nc);
	}
	for (nc = DEB; nc < N_CHR; nc++){	
		k = BLITZ[rand()%N_F_L];	 /* eviter les fragments fixes */
		L = loop[CC][nc][k]+loop[CC][nc][k+1];
		for (i = 0; L == 0 && i < 3; i++){
			k = BLITZ[rand()%N_F_L];	 /* eviter les fragments fixes */
			L = loop[CC][nc][k]+loop[CC][nc][k+1];
		}
		/*if (ORDRE)
			re_ordonne(k);*/ /* replacera les fragments les uns par rapport aux autres */
		if (L > 0){
		   if ((M = mini[k]+mini[k+1]) < L && rand()%6){
			loop[CC][nc][k] = mini[k]+rand()%(L-M);
		   }
		   else {
		   	/*if (rand()%6 || opti[k] > L || opti[k+1] > L)*/
				loop[CC][nc][k] = rand()%(L);
		   	/*else {
				loop[CC][nc][k] = (opti[k]+rand())%L;
			}*/
		   }
		   loop[CC][nc][k+1] = L - loop[CC][nc][k];
		}
/*	for (k = 0; k < N_FRAG+1; k++)
		i+= loop[CC][nc][k];
	fprintf(stdout,"\n\tRELOUP %5d \n\n", i);*/

		ETC[nc] = positionne(nc);
		/*fprintf(stdout,"MUTANT %4d %.1f\n", nc, -ETC[nc]);*/
	}

return ETC;	
}
/********************************************************/
/* alignement						*/
/********************************************************/
double	*alignement(double *ETC)
{
	int	k, n, nc, L, N_REM, dk, NRV = 10, r;
	
/*	for (nc = 0; nc < DEB; nc++){	ETC[nc] = positionne(nc); }*/

	for (nc = 0; nc < N_CHR; nc++){/* eviter les fragments fixes */	
		/*if (ORDRE)
			re_ordonne(0);*/
		N_REM = MAXIM - N_RF;
	   if (rand()%2 == 0){
		NRV = (int)((float)(N_REM)/(N_FRAG+1))+1;
		for (k = 0; k < N_FRAG+1 && N_REM > NRV; k++){
			N_REM -= loop[CC][nc][k] = rand()%NRV;
		}
	   }
	   else {
		for (k = 0; k < N_FRAG+1 && N_REM > mini[k]+1+2*opti[k]; k++){
			N_REM -= loop[CC][nc][k] = mini[k]+rand()%(1+2*opti[k]);
		}
	   }
	   if (N_REM > 0){
		for (k = dk = rand()%(N_FRAG+1); k < N_FRAG && N_REM > 0; k++){
			loop[CC][nc][k] += r = rand()%N_REM;
			N_REM -= r;
		}
		for (k = 0; k < dk && N_REM > 0; k++){
			loop[CC][nc][k] += r = rand()%N_REM;
			N_REM -= r;
		}
		for (; k < dk; k++)
			loop[CC][nc][k] += 0;
		loop[CC][nc][dk] += N_REM;
		N_REM = 0;
	   }
	   else {
	   	for (; k < N_FRAG+1; k++)
			loop[CC][nc][k] = 0;
	   }
/*
	for (k = 0, r = 0; k < N_FRAG; k++)
		r+= pf[k];
	fprintf(stdout,"PELOUP %5d -", r);
	for (k = 0, r = 0; k < N_FRAG+1; k++)
		r+= loop[CC][nc][k];
	fprintf(stdout,"\tPELOUP %5d \n", r);
*/
	/*   ETC[nc] = positionne(nc);*/
	}

return ETC;	
}
/********************************************************/
/* boucle						*/
/********************************************************/
void	boucle(double *ETC, char *name)
{
	int	g, k, r;

	for (g = 0; g < N_CHR; g++){	
	/*for (k = 0, r = 0; k < N_FRAG+1; k++)
		r+= loop[CC][g][k];
	fprintf(stdout,"\n\tPELOUP %5d \n\n", TS[MDL][0]);
	fprintf(stdout,"\tGELOUP %5d \n", r);*/ /* OK */
	   ETC[g] = positionne(g);
	}
	classe(ETC);
	for (g = 0; g < N_GEN; g++){
		mutation(ETC);
		classe(ETC);
		/*if (g%20 == 0)
			fprintf(stdout, "\tgeneration %3d %9.1f\n", g, -Emaxou);*/
		if ((INCR += N_CHR) > STOP)
			break;
	}

	fprintf(stdout, "Generation %3d %9.0f  %s %5d %s\n\n", g, -Emaxou, name, P_RES, CMPND[PDBLUS]);

}
/********************************************************/
/* pub							*/
/********************************************************/
void	pub()
{
	fprintf(stdout, "\n\t  Le programme TITO propose de chercher le repliement compatible\n");
	fprintf(stdout, "\t avec une(des) sequence(s), en vue de la modelisation moleculaire.\n");
	fprintf(stdout, "\t Les coordonnees sont issues d'un support en format PDB \n");
	fprintf(stdout, "\t Les trois fichier de sortie sont : id.pdb id.log et id.msf.\n");
	fprintf(stdout, "\t Les deux sequences utiles dans l'alignement final sont :\n");
	fprintf(stdout, "\t  _ seq_support (correspondant a la sequence du support 3D)\n");
	fprintf(stdout, "\t  _ seq_modele de la proteine a modeliser\n\n");

	fprintf(stdout, "\n\tusage : tito fichier_d_entree\n\n");
	exit(1);
}
/********************************************************/
/* lecture						*/
/********************************************************/
char	**lecture_spot(char **arg, int argc, char **argv)
{
	int	i, natte, chatte, val, r;
	FILE	*pot = NULL;
	char	line[LL], nom[LL];

	for (i = 0; i < N_TYPE; i++)
		N_NOM[i] = 0;

	if (argc == 2) {	
	   if (!(pot = ouvre_fichier(pot, argv[1], "r", "du fichier d'entree")))
		exit(1);

	   if (!(arg = NEWN(8, char *) ))
		exit(1);
	   for (i = 0; i < 8; i++){	
		if (!(arg[i] = NEWN(LL, char ) ))
			exit(1);
		for (r = 0; r < LL; r++)
			arg[i][r] = '\0';
	   }

	   arg[6][0] = ' ';
	   while(fgets(line, LL, pot)){
		val = 1; natte = 0; chatte = -1;
		if (strncmp(line, "ALIMNT",6) == 0 || strncmp(line, "ALIMDL",6) == 0){
			sscanf(line+6,"%s %d %d",arg[1], limmsf, limmsf+1);
		}
		else
		if (strncmp(line, "STTSPT",6) == 0){
			sscanf(line+6,"%s",arg[2], &natte, &chatte);
		}
		else
		if (strncmp(line, "STTMDL",6) == 0){
			sscanf(line+6,"%s %d %d",arg[3]);
		}
		else
		if (strncmp(line, "POLCHA",6) == 0){
			sscanf(line+6,"%s", arg[6]);
		}
		else
		if (strncmp(line, "SEQSPT",6) == 0){
			sscanf(line+6,"%s %d",arg[4], &val);
			nom_sm[SPT] = add_name(nom_sm[SPT], arg[4], SPT);
			SCALE[SPT] = add_val(SCALE, N_NOM[SPT], val, SPT);
		}
		else
		if (strncmp(line, "SEQMDL",6) == 0){
			sscanf(line+6,"%s %d",arg[5], &val);
			nom_sm[MDL] = add_name(nom_sm[MDL], arg[5], MDL);
			SCALE[MDL] = add_val(SCALE, N_NOM[MDL], val, MDL);
		}
		else
		if (strncmp(line, "STSPRD",6) == 0){
			sscanf(line+6,"%s %d",arg[7], &val);
			if (val == 0)
				continue;
			nom_sm[PRD] = add_name(nom_sm[PRD], arg[7], PRD);
			SCALE[PRD] = add_val(SCALE, N_NOM[PRD], val, PRD);
		}
		else
		if (strncmp(line, "HDRPHB",6) == 0){
			sscanf(line+6,"%s %d",arg[7], &val);
			if (val != 0) {
				nom_sm[HYD] = add_name(nom_sm[HYD], arg[7], HYD);
				SCALE[HYD] = add_val(SCALE, N_NOM[HYD], val, HYD);
			}
		}
		else
		if (strncmp(line, "SUCCES",6) == 0){
			lect_succes(line);
			/*sscanf(line+6,"%s",succes);*/
		}
		else
		if (strncmp(line, "CHRMSN",6) == 0)
			sscanf(line+6,"%d", &N_CHR);
		else
		if (strncmp(line, "GENERA",6) == 0)
			sscanf(line+6,"%d", &N_GEN);
		else
		if (strncmp(line, "NB_SUP",6) == 0)
			sscanf(line+6,"%d", &N_SUP);
		else
		if (strncmp(line, "HCAHCA",6) == 0)
			sscanf(line+6,"%d", &HCAHCA);
		else
		if (strncmp(line, "MINIMA",6) == 0)
			sscanf(line+6,"%d", &MINIMA);
		else
		if (strncmp(line, "VERBES",6) == 0)
			sscanf(line+6,"%d", &VERBES);
		else
		if (strncmp(line, "INDELS",6) == 0)
			sscanf(line+6,"%d", &INDELS);
		else
		if (strncmp(line, "VALSEQ",6) == 0)
			sscanf(line+6,"%d", &VALSEQ);
		else
		if (strncmp(line, "VALSTS",6) == 0)
			sscanf(line+6,"%d", &VALSTS);
		else
		if (strncmp(line, "VALHYD",6) == 0) {
			/*VALHYD = 10;  ESSAI DE TITO */
			sscanf(line+6,"%d", &VALHYD);
		}
		else
		if (strncmp(line, "DECIDL",6) == 0)
			sscanf(line+6,"%d", &DECIDL);
		else
		if (strncmp(line, "VALIDL",6) == 0)
			sscanf(line+6,"%d", &VALIDL);
		else

		if (strncmp(line, "ACTSIT",6) == 0){
			lect_act_sit(line);
		}
		else
		if (strncmp(line, "FRGMNT",6) == 0){
			lect_frag(line);
		}
		else
		if (strncmp(line, "END",3) == 0)
			break;
		else
		if (strncmp(line, "FRANCE",6) == 0)
			sscanf(line+6,"%d", &FRANC);
		else
		if (strncmp(line, "POLFIX",6) == 0)
			sscanf(line+6,"%d", &POLFIX);
		else
		if (strncmp(line, "CHAFIX",6) == 0)
			sscanf(line+6,"%d", &CHAFIX);
		
		for (r = 0; r < LL; r++)
			line[r] = '\0';
	   }
	}	/* argc == 2 */

	if (argc > 5) {		
	   if (!(arg = NEWN(argc, char *) ))
		exit(1);
	   for (i = 0; i <argc; i++){	
		if (!(arg[i] = NEWN(LL, char ) ))
			exit(1);
	   }
		strncpy(arg[1] , argv[1], strlen(argv[1]));
		strncpy(arg[2] , argv[2], strlen(argv[2]));
		strncpy(arg[3] , argv[3], strlen(argv[3]));
		strncpy(arg[4] , argv[4], strlen(argv[4]));
		strncpy(arg[5] , argv[5], strlen(argv[5]));
		nom_sm[SPT] = add_name(nom_sm[SPT], arg[4], SPT);
		nom_sm[MDL] = add_name(nom_sm[MDL], arg[5], MDL);
	}
	out_pdb = arg[3];
	strcpy(file_out, out_pdb);
	strcpy(file_sup, out_pdb);
	strcpy(file_msf, out_pdb);
	strncat(out_pdb,".pdb\0",5);
	strncat(file_out,".log\0",5);
	strncat(file_sup,".rel\0",5);
	strncat(file_msf,".msf\0",5);

	N_PAR = N_CHR; 			/* ATTENTION */

	REF = NEWN(N_CHR, double);
	for (i = 0; i < N_CC; i++) {
		if (!(loop[i] = NEWN(N_CHR, int *))) exit(1);
	}
	if (!(ETC = NEWN(N_CHR, double))) exit(1);


return arg;		
}
/********************************************************/
/* entame						*/
/********************************************************/
int	entame(int da, char *nom, char chatte)
{
	int	k;

        if (!N_TOT)
		return PDBLUS;

	if (!detect_frag()){
        	fprintf(stdout, "\n\tFoncierement incompatible\n\n",N_TOT);
		return PDBLUS;
	}
	list_contact();

	if (N_NOM[SPT] == 0)
		alignement(ETC);
	else
		deduce_loop(sek);

	boucle(ETC, nom);


	if (!(RESULT = RENEWN(RESULT,PDBLUS+1,int *))) exit(1);
	if (!(RESULT[PDBLUS] = NEWN(N_FRAG+1, int))) exit(1);
	for (k = 0; k < N_FRAG+1; k++)
		RESULT[PDBLUS][k] = loop[CC][0][k];
	if (!(BIBAL = RENEWN(BIBAL,PDBLUS+1,char *))) exit(1);
	if (!(BIBAL[PDBLUS] = NEWN(LL, char))) exit(1);
	strncpy(BIBAL[PDBLUS], nom, strlen(nom));
	if (!(FINAL = RENEWN(FINAL,PDBLUS+1,double))) exit(1);
	FINAL[PDBLUS] = Emaxou;
	if (!(CHATTE = RENEWN(CHATTE,PDBLUS+1,char *))) exit(1);
	if (!(CHATTE[PDBLUS] = NEWN(1,char))) exit(1);
	CHATTE[PDBLUS][0] = chatte;

	PDBLUS++;

return PDBLUS;
}
/********************************************************/
/* tourni						*/
/********************************************************/
void 	tourni_pdb(char *arg2, char *arg6)
{
	int 	i = 0, k, nh3, coo;
	char	line[LL], argot[LL];
	FILE	*lis_pdb = NULL;

	if (!(lis_pdb = ouvre_fichier(lis_pdb, arg2, "r", "de la liste PDB"))) exit(1);
	if (N_NOM[SPT]){
	  if (FRANC)
		fprintf(stdout, "\n\tLecture du support PDB : %s\n", arg2);
	}
	else{
	  if (FRANC)
		fprintf(stdout, "\n\tLecture de la banque PDB : %s\n", arg2);
	  else
		fprintf(stdout, "Reading 3D database: %s\n", arg2);
	}

	while (fgets(line, LL, lis_pdb)){
		if (!strncmp(line, "ATOM  ", 6) || !strncmp(line, "REMARK", 6) || !strncmp(line, "HEADER", 6)){
			if (!check_pdb(arg2, arg6, 'A')) exit(1);
			entame( i, arg2, arg6[0]);
			break;
		}
		i++;
		if (line[0] == '#') continue;
		if (strncmp(line, "STTSPT",6) == 0){
			sscanf(line+6,"%s %d %d",argot, &nh3, &coo);
			arg6[0] = ' ';
			continue;
		}
		if (strncmp(line, "POLCHA",6) == 0){
			sscanf(line+6,"%s", arg6);
			continue;
		}
		if (strncmp(line, "FRGMNT",6) == 0){
			lect_frag(line);
			continue;
		}
		if (strncmp(line, "END",3) == 0){
			if (!(check_pdb(argot, arg6, 'A')))	continue;
			entame(i, argot, arg6[0]);
		}
	}
	fclose (lis_pdb);

}
/********************************************************/
/* main							*/
/********************************************************/
void	main(int argc, char *argv[])
{
	int	k, j, i, vn = 0, pn = 0, vc;

	srand((int)getpid()); /* bug si 18170 */

	if (argc == 1) pub();	

        bbk[0] = idbbbk*disbbk*cos(angbbk); bbk[1] =  disbbk*sin(angbbk); bbk[2] = -disbbk*sin(angbbk);

	arg = lecture_spot(arg, argc, argv);

	sek = lecture_msf(sek, arg[1]);
	TABLA = bd_table(sek);
	bd_sts(sek);
	if (N_NOM[PRD])
		SABLE = bd_sable(sek);

	RABLE = bd_rable(sek, SCALE, TS);

	tourni_pdb(arg[2], arg[6]);

	sortie(sek);

}
/********************************************************/
/* THE END						*/
/********************************************************/
