#define FNL	150             /* length max of a line in pdb file	*/
#define LM	50             /* length max of a line in a new MSF	*/
#define LL	150             /* length max of a line in pdb file	*/
#define UA	20
#define ua	20
#define N_AA	26

#define NO_ANGLE 500

#define	N_CC 2
#define	DEB 1

#define	N_TYPE 4 /* type de structures : MDL, SPT, STS, HYD */
#define MDL 0
#define SPT 1
#define PRD 2
#define HYD 3

#define NTER 0
#define CTER 1

#define RANDO 10000
#define INV_RANDO 1./10000

#define F1 0
#define F2 1
#define DISC 2
#define FFL 0
#define FFF 1

#define NT_CHI 4
#define CHI1 0
#define CHI2 1
#define CHI3 2
#define CHI4 3

#define AA_NUM 1
#define AT_NUM 0
#define HT_NUM 1

#define N_CTL 10
#define N_ATOM 5
#define N 0
#define CA 1
#define C 2
#define O 3
#define CB 4
#define CG 5
#define CD 6
#define CE 7
#define CZ 8

#define NCB 0
#define N_NCB 1

#define N_COIN 6
#define ALFA 0
#define TAU 1
#define D2 2
#define D3 3
#define D4 4
#define D5 5

#define AA 'A' - 'A'
#define GA 'G' - 'A'
#define ZA 'Z' - 'A'

#define ALFA 0
#define BETA 1
#define COIL 2
#define N_ST 3

#define XX      0
#define YY      1
#define ZZ      2
#define OC      0
#define BF      1
#define OCBF    2

/* #define ATM_N 0
#define ATM_CA 1
#define ATM_C 2
#define ATM_O 3
#define ATM_CB 4 */

#define N_HTAT 2
#define NS 4
#define LNS 5

#define DIM3 3

#define PI     (double)3.14159
#define D2R     (double)0.01745329252
#define R2D     (double)57.295779513 /*1./D2R           */

#define LET 0
#define CONS 1
#define HYDRO 2
#define N_ETAT 3

#define BORDURE 1
#define MLF 120

#define VAL_AS -200
#define sqr_dis_pmf 2.4*2.4
#define dis_pmf 2.4

/* -------------------------------------------------------------------- */
/* macros                                                               */
/* -------------------------------------------------------------------- */

#define PDB(f,n,s,a,d,o) \
	fprintf(f,"ATOM %6d  %3s %3s %5d    %8.3f%8.3f%8.3f  %4.2f %5.2f\n",n,s,a,d,o[XX],o[YY],o[ZZ], o[DIM3+OC], o[DIM3+BF])
#define P_0(f,n,s,a,d,x,y,z) \
	fprintf(f,"ATOM %6d  %3s %3s %5d    %8.3f%8.3f%8.3f%s\n",n,s,a,d,x,y,z, occ)
#define PL_0(f,e,s) \
	fprintf(f,"%c %c\n",e,s)
#define PA_0(f,e,s) \
	fprintf(f,"%c %cu0",e,s)
#define PLT(f,e,s,o) \
	fprintf(f,"%c %c%c0  %.3f %.3f %.3f",e,s,s,o[XX],o[YY],o[ZZ])
#define PL1(f,e,s,o) \
	fprintf(f,"%c %c%c1  %.3f %.3f %.3f",e,s,s,o[XX],o[YY],o[ZZ])
#define PLB(f,o) \
	fprintf(f," %.3f %.3f %.3f",o[XX],o[YY],o[ZZ])
#define PA(f,e,s,o) \
	fprintf(f,"%c %c%c1 ",e,s,s)
#define PAB(f,ad) \
	fprintf(f," %.3f",R2D*ad)
#define PABS(f) \
	fprintf(f," 116. 121. 111. 119.")

/*----------------------------------------------------------------------*/
/* parametres                                                           */
/*----------------------------------------------------------------------*/

#define D_EXT  9.5 
#define D_INT  3.5 * 3.5      /* SQR_DIS */
#define i_D_CA  3.5 * 3.5      /* SQR_DIS */
#define s_D_CA  4.1 * 4.1      /* SQR_DIS */

#define i_D2_B  6.3 * 6.3      /* SQR_DIS */
#define s_D2_B  7.3 * 7.3      /* SQR_DIS */
#define i_D3_A  4.6 * 4.6      /* SQR_DIS */
#define s_D3_A  5.5 * 5.5      /* SQR_DIS */
#define i_D3_B  9.1 * 9.1      /* SQR_DIS */
#define s_D3_B  10.6 * 10.6      /* SQR_DIS */
#define i_D4_A  5.4 * 5.4      /* SQR_DIS */
#define s_D4_A  6.4 * 6.4      /* SQR_DIS */
#define i_D4_B  12.6 * 12.6      /* SQR_DIS */
#define s_D4_B  14.1 * 14.1      /* SQR_DIS */
#define i_D_PMF  1.3 * 1.3      /* SQR_DIS */
#define s_D_PMF  1.8 * 1.8      /* SQR_DIS */

/*----------------------------------------------------------------------*/
/* structures                                                            */
/*----------------------------------------------------------------------*/

typedef struct _residu {               /* -- residue			*/
        struct _residu  *next;         /* next in list			*/
        char            let;           /* residue name (1 letter)       */
} Residu;

typedef struct  {                      /* -- residue			*/
        char            let;           /* residue name (1 letter)       */
} Seq;

typedef struct  {                      /* -- contact  */
        int            ctt[3];           /*        */
} Ctt;

typedef struct _model {                      /* -- residue			*/
        char    let, cons;           /* residue name (1 letter)       */
        int     num[2];     /* numero du residu                        */
        char    atm[2][5];  /* numero de l'atome                       */
	char	chain;
        double  xyz[3];       /* cartesian coordinates    	*/
	double	ocbf[2]; /* Occupancies and B-factor */
} Model;

typedef struct _molec{              /* -- contrainte de distance                     */
        int             num[2];     /* numero du residu                        */
        char            atm[2][5];  /* numero de l'atome                       */
	char		chain;
        double          xyz[3];  /* constante de force et valeurs de la contrainte */
	double	ocbf[2]; /* Occupancies and B-factor */
        struct _molec   /* *prev,*/ *next;   /* next in list                       */
} Molec;

/*----------------------------------------------------------------------*/
/* End of tito.h                                                       */
/*----------------------------------------------------------------------*/

